unit Unit1;

{$mode objfpc}{$H+}

interface

uses
{$IFDEF WINDOWS}
  Windows,                             // important that Windows goes before Classes
{$ELSE}
  BaseUnix, TermIO, unix,
{$ENDIF}
  Classes, SysUtils, Forms, Controls, Graphics, Dialogs, StdCtrls, ExtCtrls,
  Menus, Clipbrd, Math, LCLType, LCLIntf, Unit2, Unit3;

// Math is needed for min/max
// LCLType is needed for virtual key definitions
// BaseUnix is needed for file I/O under linux
// TermIO is needed for serial I/O under linux
// LCLIntf is needed for GetKeyState - used to determine capslock setting

////////////////////////////////////////////////////////////////////////////////
//                                                                            //
// remember to add -dUseCThreads to:                                          //
//                                                                            //
// Project -> Project Options -> Custom Options                               //
//                                                                            //
////////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////////
//                                                                            //
// before compiling, you need to have installed libasound2.dev with:          //
//                                                                            //
// sudo apt-get install libasound2-dev                                        //
//                                                                            //
////////////////////////////////////////////////////////////////////////////////

type

  { TForm1 }

  TForm1 = class(TForm)
    MenuItem1A: TMenuItem;
    MenuItem1B: TMenuItem;
    MenuItem2A: TMenuItem;
    MenuItem2B: TMenuItem;
    MenuItem3: TMenuItem;
    MenuItem4A: TMenuItem;
      MenuItem4A1: TMenuItem;
      MenuItem4A2: TMenuItem;
    MenuItem4B: TMenuItem;

    MenuDivider1: TMenuItem;
    MenuItem5: TMenuItem;
    MenuItem6: TMenuItem;
      MenuItem6A: TMenuItem;
      MenuItem6B: TMenuItem;
      MenuItem6C: TMenuItem;
      MenuItem6D: TMenuItem;
      MenuItem6E: TMenuItem;
      MenuItem6F: TMenuItem;
      MenuItem6G: TMenuItem;
      MenuItem6H: TMenuItem;
    MenuItem7: TMenuItem;
      MenuItem7A: TMenuItem;
      MenuItem7B: TMenuItem;
      MenuItem7C: TMenuItem;
    MenuItem8: TMenuItem;
    MenuItem9: TMenuItem;
      MenuItem9A: TMenuItem;
      MenuItem9B: TMenuItem;
      MenuItem9C: TMenuItem;
      MenuItem9D: TMenuItem;

    MenuDivider2: TMenuItem;
    MenuItem10: TMenuItem;
      MenuItem10A: TMenuItem;
      MenuItem10B: TMenuItem;
      MenuItem10C: TMenuItem;

    MenuDivider3: TMenuItem;
    MenuItem11: TMenuItem;
    MenuItem12: TMenuItem;

    Bevel1: TBevel;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;

    Shape1: TShape;
    Panel1: TPanel;
      VTcursor: TLabel;
      Image1: TImage;
      Image2: TImage;
      Image3: TImage;
      Memo1: TMemo;
      Panel2: TPanel;
        Label9: TLabel;

    Timer1: TTimer;
    Timer3: TTimer;
    Timer4: TTimer;

    PopupMenu1: TPopupMenu;
    OpenDialog1: TOpenDialog;
    SaveDialog1: TSaveDialog;
    FontDialog1: TFontDialog;
    ApplicationProperties: TApplicationProperties;

    procedure ApplicationPropertiesActivate(Sender: TObject);
    procedure ApplicationPropertiesDeactivate(Sender: TObject);
    procedure ApplicationPropertiesIdle(Sender: TObject; var {%H-}Done: Boolean);
//  procedure ApplicationProperties1Restore(Sender: TObject);

    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
//  procedure FormResize(Sender: TObject);
//  procedure FormWindowStateChange(Sender: TObject);

    procedure FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure FormKeyPress(Sender: TObject; var Key: char);
    procedure FormKeyUp(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure MenuItem8Click(Sender: TObject);

    procedure Panel1MouseMove(Sender: TObject; {%H-}Shift: TShiftState; X, Y: Integer);
    procedure Panel1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Panel1MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure FormMouseWheel(Sender: TObject; Shift: TShiftState;
      WheelDelta: Integer; {%H-}MousePos: TPoint; var Handled: Boolean);

    procedure PopupMenu1Popup(Sender: TObject);
    procedure MenuItem1AClick(Sender: TObject);
    procedure MenuItem1BClick(Sender: TObject);
    procedure MenuItem2AClick(Sender: TObject);
    procedure MenuItem2BClick(Sender: TObject);
    procedure MenuItem3Click(Sender: TObject);

    procedure MenuItem4A1and2Click(Sender: TObject);
    procedure MenuItem4BClick(Sender: TObject);
    procedure MenuItem5Click(Sender: TObject);
    procedure MenuItem6MultiClick(Sender: TObject);
    procedure MenuItem7MultiClick(Sender: TObject);

    procedure MenuItem9MultiClick(Sender: TObject);

    procedure MenuItem10MultiClick(Sender: TObject);
    procedure MenuItem11Click(Sender: TObject);

    procedure Timer1Timer(Sender: TObject);
//  procedure Timer2Timer(Sender: TObject);
    procedure Timer3Timer(Sender: TObject);
    procedure Timer4Timer(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}

{ TForm1 }

const SoftwareKey='\Software\NZ made\GFXterm';
{$IFDEF WINDOWS}
        BuildName='Graphical VT Terminal (win32)';
{$ELSE}
        BuildName='Graphical VT Terminal (LINUX)';
{$ENDIF}
        BuildDate='(build: 21-september-2021)'+{'   RC5'}'  test';

type str255=string[255];

const ROWS=24;         // 24 or 36 or 43
      COLS=80;         // win32 limit: 1036 pixels max if 1024 pixel wide physical screen

        pL='      ';   // left packing spaces for ShowMessage calls
        pR='      ';   // right packing spaces for ShowMessage calls

const ConfigName:string='~/.config/GFXterm64.cfg';
        CommName:string='';              // currently connected comm port, set to '' on disconnect
        CommRate:integer=0;              // currently used baud rate, set to 0 on disconnect
        LastName:string='';              // last successfully connected comm port name
        LastRate:integer=0;              // last successfully used baud rate

var LogFile:text;

var cellW, cellH:integer;                // with and height of character cell
             SCR:TCanvas;                // used as a shortcut to text screen
             GFX:TCanvas;                // used as a shortcut to graphics screen

const
//    FontIndex:integer=1;               // index of font in FontList, 0=manual
      FGdefault:integer=7;               // default text FG colour
      BGdefault:integer=0;               // default text BG colour
       FGcolour:integer=7;               // text foreground colour
       BGcolour:integer=0;               // text background colour
       InvertBW:boolean=false;           // flag to indicate black and white have both been inverted

       TxtStyle:TFontStyles=[];          // text style (we only use fsUnderline and fsBold)
        DimText:boolean=false;           // low intensity flag
        InvText:boolean=false;           // inverse video flag
         DimOpt:integer=0;               // enabled / bright 1 / bright 2
      CursorVis:boolean=true;            // hide/show text cursor
      VTinsMode:boolean=false;           // VT insert / replacement mode

           Xpos:integer=1;               // initial cursor column
           Ypos:integer=1;               // initial cursor row
          XYnew:boolean=false;           // flag indicating cursor has moved
        Tmargin:integer=1;               // VT100 scroll area top margin
        Bmargin:integer=ROWS;            // VT100 scroll area bottom margin

          lastK:char=#$00;               // last ascii key pressed. #255==\n
          lastC:char=#$00;               // last ascii character printed

         MouseX:integer=-1;              // last mouse X position
         MouseY:integer=-1;              // last mouse Y position

         CRwait:integer=0;               // the number of <CR> characters being waited on

            TS1:int64=0;                 // timestamp of last serial/network port data read
            TS2:int64=0;                 // timestamp of last serial/network port data write
            TS3:int64=0;                 // timestamp of last VT command decoded
            TS4:int64=0;                 // timestamp of start of connection
            TS5:int64=0;                 // timestamp of start of paste operation
            TS6:int64=0;                 // timestamp of end of paste operation (or current time if in progress)
            TS7:int64=0;                 // timestamp of last serial I/O thread activity
            TS8:int64=0;                 // timestamp of last keyboard activity (key-down or key-up event)
            TS9:int64=0;                 // timestamp of last call to ApplicationPropertiesIdle (calls stop if LCL is swamped)

         RxBusy:boolean=false;
         TxBusy:boolean=false;

            ErrorCode:integer=0;                               // <>0: number indicating the cause of the last internal error
            ErrorPort:string='';                               // name of serial port opened when error occurred
            ErrorData:array [1..4] of integer=(0,0,0,0);       // data passed to error message display routine (in Timer4)
                 LCFn:integer=0;                               // last communications function called (always reset to zero upon return)

            RxBuffer:record                                    // serial input (ring) buffer
                       data:array [0..$3FFFF] of char;         // 256k
                       head:integer;
                       tail:integer
                     end=(data:''; head:0; tail:0);

            TxBuffer:record                                    // serial output (ring) buffer
                       data:array [0..$3FFF] of char;          // 16k
                       head:integer;
                       tail:integer
                     end=(data:''; head:0; tail:0);

            PasteBuffer:record
                          data:string;                         // paste buffer (characters to paste)
                          count:integer;                       // length of buffer
                          index:integer                        // index into buffer
                        end=(data:''; count:0; index:0);

const
{$IFDEF WINDOWS}
      BreakCounter:integer=-1;           // win32: used to time sending a break
{$ENDIF}
         CONNECTED:integer=0;            // 0 = offline, 1 = USB check,
                                         // 2 = serial,  4 = network
         LOGTOFILE:boolean=false;        // true if logging text to a file
         SKIPPRINT:boolean=false;        // buffer overflow, move cursor but no text o/p
         DEBUGMODE:integer=0;            // select what diagnostics to send to console
         MouseMode:integer=0;            // mouse mode and reporting protocol, 0=disabled

         flagFOCUS:boolean=false;        // set true by application activate, false by deactivate
         flagPOPUP:boolean=false;        // user to set true when a popup has locked focus,
                                         // for cases when application deactivate/activate fails (such as InputQuery)
         LABELTEST:boolean=false;

         ScrollLCK:boolean=false;        // signal scroll lock -> suspend screen output
         ScrollTOS:boolean=false;        // signal to scroll screen/cursor to Top Of Screen

var TextStore:array [1..ROWS] of array [1..COLS] of char;

const CPC:array [0..15] of TColor=(clBlack, clNavy, clGreen, clTeal,
                                   clMaroon, clPurple, clOlive, clSilver,
                                   clGray, clBlue, clLime, clAqua,
                                   clRed, clFuchsia, clYellow, clWhite);
{   (dim)           (bright)
0 = Black 	8 = Gray
1 = Blue 	9 = Light Blue
2 = Green 	A = Light Green
3 = Aqua 	B = Light Aqua     (Cyan)
4 = Red 	C = Light Red
5 = Purple 	D = Light Purple   (Magenta)
6 = Yellow 	E = Light Yellow
7 = White 	F = Bright White
}

const CVT:array [0..15] of TColor=(clBlack, clMaroon, clGreen, clOlive,
                                   clNavy, clPurple, clTeal, clSilver,
                                   clGray, clRed, clLime, clYellow,
                                   clBlue, clFuchsia, clAqua, clWhite);

{       (0-7 = dim, 8-15 = bright)
30	Black
31	Red
32	Green
33	Yellow
34	Blue                  TColor($FF8080) = bright blue, as per teraterm
35	Magenta   (Purple)
36	Cyan      (Aqua)
37	White

note: mmbasic should stop using bright-black (gray) for plain
text in the editor, and instead use dim-white (silver)
}

var  PAL:array [0..15] of TColor;              // holds colour palette, normally copied from CVT






(*
function GetTickCount64:int64;
const multiplier=24*60*60*1000;
begin
  Result:=trunc(Now*multiplier)
end;
*)



// returns how much time has elapsed since GetTickCount64 was assigned to a counter
// (placed up here as is used within serial.inc)
function timesince(counter:int64):int64;
begin
  result:=GetTickCount64-counter
end;



// place data into the serial output buffer, ready to be transmitted. on entry
// may wait up to 200ms for space in the output buffer to become free. returns
// false if unable to write because of blocking
// (placed up here as is used within engine.inc)
function QueueSerialWrite(Buffer:str255):boolean;
var mark:int64;
    flag:boolean;
     I,J:integer;
begin
  mark:=GetTickCount64;
  repeat
    I:=TxBuffer.head-TxBuffer.tail;
    if I<0 then I:=I+sizeof(TxBuffer.data);                            // calculate free space in TxBuffer
    flag:=(I<(length(Buffer)+16));                                     // require # characters + 16 free
    if not flag then sleep(20)                                         // if not enough space, wait...
  until flag or (timesince(mark)>200);                                 // loop until either enough space or timeout

  result:=flag;                                                        // returns false if no space in TxBuffer

  if flag then
  begin
    I:=TxBuffer.Head;
    for J:=1 to length(Buffer) do                                      // if enough space, load data into TxBuffer
    begin
      TxBuffer.data[I]:=Buffer[J];
      I:=(I+1) mod sizeof(TxBuffer.data)
    end;
    TxBuffer.head:=I
  end
end;






{$I beeper.inc}
{$I video.inc}

{$IFNDEF WINDOWS}
  {$I serial.inc}              // linux serial communications
{$ELSE}
  {$I comms(w32).inc}          // windows serial communications
{$ENDIF}

{$I engine.inc}






// read configuration file, only called once (at startup)
function ReadConfigurationFile:boolean;
var T:text;
    S:string;
    I:integer;
begin
  result:=false;

  if FileExists(ConfigName) then
  try
//  writeln('opening config file');
    AssignFile(T, ConfigName);
    Reset(T);

    ReadLn(T, S);
//  writeln('version = ',S);
    if S='v4b' then
    begin
//    writeln('version matches');
      ReadLn(T, LastName);
      LastName:=trim(LastName);
      ReadLn(T, LastRate);

      ReadLn(T, S);
      S:=trim(S);
      Form1.VTcursor.Font.Name:=S;
      ReadLn(T, I);
      Form1.VTcursor.Font.Size:=I;

      ReadLn(T, I);
      Case I of 1:Form1.MenuItem6A.Checked:=true;
                2:Form1.MenuItem6B.Checked:=true;
                3:Form1.MenuItem6C.Checked:=true;
                4:Form1.MenuItem6D.Checked:=true;
                5:Form1.MenuItem6E.Checked:=true;
                6:Form1.MenuItem6F.Checked:=true;
                7:Form1.MenuItem6G.Checked:=true;
                8:Form1.MenuItem6H.Checked:=true
             else I:=7
      end;  { of case }
      if I=8 then InvertBW:=true;
      FGdefault:=min(I, 7);
      FGcolour:=FGdefault;

      ReadLn(T, I);
      case I of 0:Form1.MenuItem7A.Checked:=true;
                1:Form1.MenuItem7B.Checked:=true;
                2:Form1.MenuItem7C.Checked:=true
             else I:=0
      end;  { of case }
      DimOpt:=I;

      ReadLn(T, I);
      BELLvolume:=min(max(0, I), 100);

      for I:=0 to 15 do                                                // retrieve palette
      begin
        readln(T, S);
        S:=trim(S);
        PAL[I]:=StrToInt(S)
      end;

      if InvertBW then begin                                           // invert black and white
                         PAL[0]:=$00FFFFFF-PAL[0];                     // black -> white
                         PAL[15]:=$00FFFFFF-PAL[15]                    // white -> black
                       end;
//    writeln('parameters read ok');
      result:=true
    end;

//  writeln('closing config file')
    CloseFile(T)
  except
//  writeln('exception');
    try CloseFile(T) except end
  end
end;



// write configuration file, called at shutdown - may also be called at other times
procedure WriteConfigurationFile;
var T:text;
    I:integer;
begin
  if not ForceDirectories(ExtractFileDir(ConfigName)) then ShowMessage(#13+pL+'Failed to create config directory:'+pR+#13
                                                                          +pL+ExtractFileDir(ConfigName)+pR+#13) else
  try
    AssignFile(T, ConfigName);
    ReWrite(T);

    WriteLn(T, 'v4b');
    WriteLn(T, LastName);
    WriteLn(T, LastRate);
    WriteLn(T, Form1.VTcursor.Font.Name);
    WriteLn(T, Form1.VTcursor.Font.Size);
    if InvertBW then WriteLn(T, 8)
                else WriteLn(T, FGdefault);
    WriteLn(T, DimOpt);
    WriteLn(T, BELLvolume);

    if InvertBW then WriteLn(T,'0x'+Format('%.6x',[$00FFFFFF-PAL[0]]))
                else WriteLn(T,'0x'+Format('%.6x',[PAL[0]]));
    for I:=1 to 14 do WriteLn(T,'0x'+Format('%.6x',[PAL[I]]));
    if InvertBW then WriteLn(T,'0x'+Format('%.6x',[$00FFFFFF-PAL[15]]))
                else WriteLn(T,'0x'+Format('%.6x',[PAL[15]]));
    CloseFile(T)
  except
    try CloseFile(T) except end;
    ShowMessage(#13+pL+'Failed to write to config file:'+pR+#13
                   +pL+ConfigName+pR+#13)
  end
end;



// reset terminal. levels are:
// 0: full reset, but leaves serial port open
// 1: clear text and graphics layers, turn off graphics, home cursor
procedure ResetTerminal(level:integer);
var mark:int64;
begin
  if LOGTOFILE and (level=0) then                                      // close log file if open
  begin
    LOGTOFILE:=false;
    try Flush(LogFile) except end;
    try CloseFile(LogFile) except end
  end;

  if level=0 then                                                      // serial port, Rx, Tx, paste buffers
  begin
    SerialToIdle:=true;                                                // halt serial I/O thread

    SerialTicker:=3;
    mark:=GetTickCount64;
    repeat until (SerialTicker=0) or (timesince(mark)>300);            // wait for thread to become idle

    RxBuffer.tail:=RxBuffer.head;                                      // empty Rx ring buffer
    TxBuffer.head:=TxBuffer.tail;                                      // empty Tx ring buffer

    SerialToIdle:=false;                                               // resume serial I/O thread

    PasteBuffer.index:=0;
    PasteBuffer.count:=0;
    PasteBuffer.data:=''                                               // empty paste buffer
  end;

  if level=0 then                                                      // reset VT settings
  begin
    DimText:=false;                                                    // reset text attributes
    InvText:=false;
    TxtStyle:=[];

    FGcolour:=FGdefault;                                               // reset text colours
    BGcolour:=BGdefault;

    GFXink(255, 0 ,0 ,1);                                              // default GFX pen: red, 1-pixel wide

    MouseMode:=0;                                                      // turn off mouse reporting
    CursorVis:=true;                                                   // unhide cursor
    VTinsMode:=false;                                                  // select replacement mode

    Tmargin:=1;                                                        // reset VT scroll margins
    Bmargin:=ROWS
  end;

  clear(1, 1, COLS, ROWS);                                             // clear text layer
  GFXclear(0, 0, Gw, Gh);                                              // clear graphics layer
  Form1.Image2.Hide;                                                   // hide graphics layer
  gotoxy(1,1)                                                          // home cursor
end;



// from milliseconds input, return days, hours, minutes, seconds in a formatted string
function DHMStime(ms:int64):string;
var D,H,M,S:int64;
begin
  D:=ms div (24*60*60*1000);
  dec(ms, D*24*60*60*1000);
  H:=ms div (60*60*1000);
  dec(ms, H*60*60*1000);
  M:=ms div (60*1000);
  dec(ms, M*60*1000);
  S:=ms div 1000;
  dec(ms, S*1000);
  if D=1  then result:=format('%d day, %.2dh %.2dm %.2ds',[D, H, M, S]) else
  if D<>0 then result:=format('%d days, %.2dh %.2dm %.2ds',[D, H, M, S]) else
  if H<>0 then result:=format('%dh %.2dm %.2ds',[H, M, S]) else
  if M<>0 then result:=format('%dm %.2ds', [M, S]) else
  if S=1  then result:=            '1 second' else
  if S<>0 then result:=IntToStr(S)+' seconds' else
               result:=IntToStr(ms)+' ms'
end;



(*
// obtain dimensions of working area of a maximized form
function GetMaximizedDimensions(var X,Y:integer):boolean;
var TestForm:TForm;
       point:TPoint;
           I:integer;
begin
  TestForm:=TForm.Create(nil);                                         // create test form objact
  TestForm.SetBounds(0,0,128,64);                                      // 128 pixels wide, 64 pixels high
  TestForm.AlphaBlend:=true;                                           // allow alpha blending
  TestForm.AlphaBlendValue:=0;                                         // make completely transparent
  TestForm.WindowState:=wsMaximized;                                   // maximize
  TestForm.ShowInTaskBar:=stNever;                                     // ensure form ion does NOT flash up on taskbar
  TestForm.Show;                                                       // show (invisible) form

  I:=20;                                                               // max 20 loops at 50ms each = 1000ms
  repeat
    Application.ProcessMessages;
    sleep(50);
    X:=TestForm.Width;                                                 // grab width
    Y:=TestForm.Height;                                                // grab height
//  writeln(X, ' x ', Y);
    dec(I)
  until (I=0) or ((X<>128) and (Y<>64));                               // keep looping until size has maximized, or timeout
  result:=(I<>0);                                                      // fail if we timed out

  FreeAndNil(TestForm);                                                // dispose of test form

  point.X:=Form1.Left;
  point.Y:=Form1.Top;
  I:=-Form1.ScreenToClient(point).X;                                   // find left boarder width, change sign as this returns a -ve number
  dec(X, 2*I);                                                         // remove width of left and right boarders (assumes they are equal)
  dec(Y, I)                                                            // ##### assume bottom boarder is same width as side boarders ##### <<<<<<<<<< this may be WRONG <<<<<<<<<<
end;                                                                   // ################################################################ ^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
*)





////////////////////////////////////////////////////////////////////////////////
// Timer event handlers (x3)
//
// Timer1: 15mS nominal tick rate (may over-run up to 30ms or so)
//         flash cursor: 500mS on, 500mS off
//         update status bar and cursor location
//         [handle break signalling to 1455 firmware - windows only]
//         process ring buffer to screen (max 30mS total runtime)
// Timer3: 300ms, paste ticker, interval changes to 15ms while pasting
// Timer4: 300ms, USB connection check, also error message popup handler
//
// note: Timer1 may stamp all over the other timers if
//       it needs to process large quantities of data
////////////////////////////////////////////////////////////////////////////////
procedure TForm1.Timer1Timer(Sender: TObject);
const startup:boolean=true;
      holdoff:integer=-90;                                             // holdoff time (90ms) before starting window fade-in
        flag1:integer=0;                                               // 0,1,2,3 ring counter, incremented every 250ms
        flag2:integer=0;
        flag4:integer=-1;
        tock:boolean=false;
//       mark:int64=0;                                                 // time at (near) start of ISR. used to calculate lost ISRs
//        UDC:integer=0;                                               // up/down counter, used for defining threshold for skipping
var mark, I64:int64;
     BusyFlag:boolean;
         LEDs:{$IFDEF WINDOWS}dword{$ELSE}cardinal{$ENDIF};
//        I64:int64;
         I, J:integer;
         S, T:string;
           ch:char;
begin
{
// ******** handle LCL swamping, which will result in both (a) missed timer interrupts, and, (b) the LCL inserting 'catchup' interrupts
//I64:=mark;
  if timesince(mark)<5  then exit;                                     // skip any 'catchup' interrupts that the LCL throws at us
  if timesince(mark)<20 then UDC:=max(0, UDC-1)                        // we are within a few ms of the set time interval (15ms)
                        else UDC:=UDC+3;                               // we are substantially over  "   "   "      "     ( "  )
  mark:=GetTickCount64;
  if UDC>20 then
  begin                                                                // have exceeded limit for over-runs
//  writeln(timesince(I64), #9, 'SKIPPING');
    UDC:=10;                                                           // 10 --> once kicked in, skips every 5th or so time through
    exit                                                               // ... this is sufficient to allow dialogs to still function
  end; // else writeln(timesince(I64));
}

// the next 2 lines replace the above block of code. instead of measuring to see if Timer1 is running late (ie, not every 15ms or so),
// we just use a timestamp set on every call to application idle. if there are no idle calls for more that 100ms, we know that we need
// to start skipping until an idle call happens. this seems to work very well, and is much simpler than the above.
// WARNING: idle calls seem to STOP if a dialog pops up a question.ie, TSaveDialog asks if you want to overwrite an existing file.
// to get around this (bug?) we make sure we only skip every 2nd time through using a tick-tock boolean flag.

  tock:=not tock;
  if (timesince(TS9)>100) and tock then exit;
  mark:=GetTickCount64;

  // ******** run-at-startup-only, handles window fade-in **********************
  if startup then                                                      // startup with AlphaBlend=true, slow fade in after holdoff
  begin
    if holdoff<0 then inc(holdoff, Timer1.Interval)
                 else AlphaBlendValue:=min(AlphaBlendValue+17, 255);
    if AlphaBlendValue=255 then
    begin
      AlphaBlend:=false;                                               // at 100% visibility turn off AlphaBlend
      startup:=false                                                   // set end of startup flag, never end up here again
    end
  end;

// ******** get status of serial I/O thread ************************************
  BusyFlag:=(timesince(TS7)>300);                                      // 300ms since last activity from serial thread

// ******** set CURSOR COLOUR (red/green) based on shift state *****************
  if (GetKeyState(VK_SHIFT)<0) xor
     (GetKeyState(VK_CAPITAL)=0) then begin
                                        if VTcursor.Color<>clRed then
                                        begin
                                          VTcursor.Color:=clRed;
                                          VTcursor.Font.Color:=VTcursor.Color
                                        end
                                      end
                                 else begin
                                        if VTcursor.Color<>clLime then
                                        begin
                                          VTcursor.Color:=clLime;
                                          VTcursor.Font.Color:=VTcursor.Color
                                        end
                                      end;

// ******** FLASH CURSOR: 500ms on, 500ms off **********************************
// ******** (also change mouse cursor to hourglass if BusyFlag is set) *********
// ******** (also flash 'ONLINE' indicator green/yellow if paused **************
  flag1:=((GetTickCount64 div 250) mod 4);
  if (flag1<>flag2) or XYnew then                                      // enter every 250ms, or if cursor has moved
  begin
    VTcursor.Visible:=((flag1<2) or XYnew)                             // first 500mS of 1000ms interval OR cursor has moved
        and CursorVis                                                  // AND is not turned off
        and (PasteBuffer.index=0);                                     // disable cursor while pasting
    XYnew:=false;                                                      // clear cursor movement flag
    flag2:=flag1;
    if BusyFlag then Panel1.Cursor:=crHourGlass
                else Panel1.Cursor:=crDefault;
    if ScrollLCK then if odd(flag1) then Label5.Color:=clLime
                                    else Label5.Color:=clYellow
                 else Label5.Color:=clLime                             // or clYellow if network connection open
  end;
(*
// ******** update cursor position *********************************************                              (we should probably look at moving this down to near the end)
  I:=cellH*(min(max(1, Ypos), ROWS)-1);                                                                       ////////////////////////////////////////////////////////////
  if VTcursor.Top<>I then VTcursor.Top:=I;
  I:=cellW* (min(max(1, Xpos), COLS)-1);
  if VTcursor.Left<>I then VTcursor.Left:=I;
*)
// ******** UPDATE WINDOW CAPTION and TASKBAR TEXT *****************************
  if CONNECTED<>flag4 then                                             // only update if connection status has changed
  begin
    case CONNECTED of 0:begin                                          // now disconnected
                          Form1.Caption:=BuildName+'   '+BuildDate;
                          Application.Title:='offline'
                        end;
                      2:begin                                          // now connected (serial)
                          Form1.Caption:=CommName+':'+IntToStr(CommRate)+
                                      '   '+BuildName+
                                      '   '+BuildDate;
                          Application.Title:=CommName+':'+IntToStr(CommRate)
//                        Label5.Color:=clLime
                        end;
                      4:begin                                          // now connected (network)                      // #################### MISSING ####################
                          (*
                          Form1.Caption:=ClientSocket1.Host+':'+
                                      IntToStr(ClientSocket1.Port)+
                                      '   '+BuildName+
                                      '   '+BuildDate);
                          Application.Title:=ClientSocket1.Host+':'+
                                             IntToStr(ClientSocket1.Port);
                          Label5.Color:=clYellow
                          *)
                        end
    end;  { of case }
    flag4:=CONNECTED
  end;

// ******** UPDATE STATUS BAR: Label1 - Rx char, row, col, Tx key **************
  S:=Format('%.2x row=%.2d col=%.2d key=%.2x',
            [ord(lastC), Ypos, Xpos, ord(lastK)]);
  if RightStr(S,2)='FF' then S:=LeftStr(S, length(S)-2)+'\n';          // replace 'key=FF' with 'key=\n'
  if Label1.Caption<>S then Label1.Caption:=S;

// ******** Label2 - Rx timer **************************************************
  if BusyFlag then I64:=timesince(TS7)                                 // time since last serial I/O thread loop
              else I64:=timesince(TS1);                                // time since last character received
  if I64<60000   then begin
                        S:=Format('%.5d', [I64]);
                        S:=copy(S,1,2)+'.'+S[3]+'s'
                      end else
  if I64<3600000 then begin
                        S:=Format('%.2d%.5d', [I64 div 60000, I64 mod 60000]);
                        S:=copy(S,1,2)+':'+copy(S,3,2)
                      end else
                      S:=' >1h ';
(*
  S:=Format('%.10d', [I64]);
  if I64<1000  then S:=copy(S,8,2)+'0ms' else
  if I64<60999 then S:=copy(S,6,2)+'.'+S[8]+'s' else
                    S:='>1min';
*)
  if Label2.Caption<>S then Label2.Caption:=S;
  if BusyFlag then if RxBusy then begin if Label2.Color<>clYellow then Label2.Color:=clYellow end
                             else begin if Label2.Color<>clLime then Label2.Color:=clLime end
              else if Label2.Color<>clNone then Label2.Color:=clNone;

// ******** Label3 - Tx timer **************************************************
  if BusyFlag then I64:=timesince(TS7)                                 // time since last serial I/O thread loop
              else I64:=timesince(TS2);                                // time since last character transmitted
  if I64<60000   then begin
                        S:=Format('%.5d', [I64]);
                        S:=copy(S,1,2)+'.'+S[3]+'s'
                      end else
  if I64<3600000 then begin
                        S:=Format('%.2d%.5d', [I64 div 60000, I64 mod 60000]);
                        S:=copy(S,1,2)+':'+copy(S,3,2)
                      end else
                      S:=' >1h ';
(*
  S:=Format('%.10d', [I64]);
  if I64<1000  then S:=copy(S,8,2)+'0ms' else
  if I64<60999 then S:=copy(S,6,2)+'.'+S[8]+'s' else
                    S:='>1min';
*)
  if Label3.Caption<>S then Label3.Caption:=S;
  if BusyFlag then if TxBusy then begin if Label3.Color<>clYellow then Label3.Color:=clYellow end
                             else begin if Label3.Color<>clLime then Label3.Color:=clLime end
              else if Label3.Color<>clNone then Label3.Color:=clNone;

// ******** Label4 - RxBuffer (ring buffer) usage ******************************
  I:=RxBuffer.head-RxBuffer.tail;
  if I<0 then I:=I+sizeof(RxBuffer.data);
  I:=min((I*100) div sizeof(RxBuffer.data), 99);

  if I>98 then SKIPPRINT:=true;
  if I<95 then SKIPPRINT:=false;

  S:=Format('%.2d%%', [I]);                                            // %age of (256k) ring buffer used
  if Label4.Caption<>S then
  begin
    Label4.Caption:=S;
    if I<10 then Label4.Color:=clGray else
    if I<40 then Label4.Color:=clAqua else
    if I<70 then Label4.Color:=clYellow
            else Label4.Color:=clRed
  end;

// ******** Label7 - characters remaining in paste buffer **********************
  if PasteBuffer.index<>0 then S:=Format('[%.6d]', [min(max(0, PasteBuffer.count-PasteBuffer.index+1), 999999)])
                          else S:='000000';
  if Label7.Caption<>S then
  begin
    Label7.Caption:=S;
    if timesince(TS3)>500 then Label7.Color:=clLime
                          else Label7.Color:=clAqua
  end;

// ******** Label8 - serial status lights **************************************
  if CONNECTED<>2 then Label8.Caption:='ABC DEF abc def' else
  try
{$IFDEF WINDOWS}
    GetCommModemStatus(SerialHandle,@LEDs);

    if (LEDs and   $0001  )<>0 then S:=  'DTR '    // $001     (just happens to work)
                               else S:=  'dtr ';
    if (LEDs and   $0002  )<>0 then S:=S+'RTS '    // $002     (just happens to work)
                               else S:=S+'rts ';
    if (LEDs and MS_CTS_ON)<>0 then S:=S+'CTS '    // $010
                               else S:=S+'cts ';
    if (LEDs and MS_DSR_ON)<>0 then S:=S+'DSR'     // $020
                               else S:=S+'dsr';
{$ELSE}
    FpIOCtl(SerialHandle, TIOCMGET, @LEDs);
    if (LEDs and TIOCM_DTR)<>0 then S:=  'DTR '    // $002
                               else S:=  'dtr ';
    if (LEDs and TIOCM_RTS)<>0 then S:=S+'RTS '    // $004
                               else S:=S+'rts ';
    if (LEDs and TIOCM_CTS)<>0 then S:=S+'CTS '    // $020
                               else S:=S+'cts ';
    if (LEDs and TIOCM_DSR)<>0 then S:=S+'DSR'     // $100
                               else S:=S+'dsr';
{$ENDIF}
    if Label8.Caption<>S then Label8.Caption:=S
  except
    Label8.Caption:='--- --- --- ---'
  end;

// ******** visibility of Label2 to Label8 *************************************
  Label2.Visible:=(CONNECTED<>0) or BusyFlag or LABELTEST;             // hide Rx timer if not connected (unless displaying thread time)
  Label3.Visible:=(CONNECTED<>0) or BusyFlag or LABELTEST;             // hide Tx timer if not connected (unless displaying thread time)
  Label4.Visible:=(CONNECTED<>0) or LABELTEST;                         // hide buffer %age if not connected
  Label5.Visible:=(CONNECTED<>0) or LABELTEST;                         // hide 'online' indicator if not connected
  Label6.Visible:=LOGTOFILE or LABELTEST;                              // hide 'logging' indicator if not logging
  Label7.Visible:=(PasteBuffer.index<>0) or LABELTEST;                 // hide pasting counter if paste buffer empty
  Label8.Visible:=(CONNECTED<>0) or LABELTEST;                         // hide serial status indicators if not connected

// ******** hide "BELL volume" panel after 2 seconds ***************************
  if Panel2.Tag<>0 then
  begin
    Panel2.Tag:=max(0, Panel2.Tag-Timer1.Interval);
    if Panel2.Tag=0 then begin
                           Panel2.Hide;
                           Panel2.Left:=0;
                           Panel2.Top:=0
                         end;
  end;

// ******** hide or show 'NO KEYBOARD' graphic as required *********************
  if flagFOCUS and not flagPOPUP then begin                            // accepting keyboard input
                                        If Image3.Visible then         // push to left and hide
                                        begin
                                          Image3.Hide;
                                          Image3.Left:=0
//                                        writeln('keyboard input ENABLED')
                                        end
                                      end
                                 else begin                            // keyboard input DISABLED
                                        if not Image3.Visible then     // push to right and show
                                        begin
                                          Image3.Left:=Image1.Width-Image3.Width;
                                          Image3.Show
//                                        writeln('keyboard input suspended')
                                        end
                                      end;

// ******** HANDLE BREAK (alt-B) SIGNALLING :SetCommBreak / ClearCommBreak *****                   // for Lazarus/LINUX, this is done with tcSendBreak(handle, 0)
{$IFDEF WINDOWS}
  if BreakCounter<>-1 then                                             // BreakCounter is active
  begin
    if (BreakCounter=0) and (CONNECTED=2) then
    try SetCommBreak(SerialHandle) except end;                         // set break
    Inc(BreakCounter, Timer1.Interval);

    if BreakCounter>200 then                                           // then after 200mS
    begin
      if CONNECTED=2 then
      try ClearCommBreak(SerialHandle) except end;                     // reset break
      BreakCounter:=-1                                                 // set BreakCounter to inactive value (-1)
    end
  end;
{$ENDIF}

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

// ******** process 'cursor to top of screen' keyboard command *****************
  if ScrollTOS then begin
                      if (Ypos>1) then
                      begin
                        scroll(1, 1, COLS, ROWS, 1);
                        dec(Ypos);
                        XYnew:=true
                      end;
                      ScrollTOS:=(Ypos>1) and (timesince(TS8)<1000)    // gives up after 1000ms
                    end;

// ******** process characters to the screen, inc GFX and ESC sequences ********
  if not ScrollLCK then                                                // only proceed if ScrollLCK flag is not set
  while (timesince(mark)<30) and (RxBuffer.head<>RxBuffer.tail) do     // drop out after 30ms maximum since start of Timer1 ISR
  begin                                                                // (only ever more than a few ms if the LCL is being swamped)
    ch:=RxBuffer.data[RxBuffer.tail];
    RxBuffer.tail:=(RxBuffer.tail+1) mod sizeof(RxBuffer.data);

    if ch=#05 then begin                                               // ENQ -> ACK, this NEVER gets processed through VT100 or GFX engines
                     if PasteBuffer.index=0 then                       // ignore ENQ during pasting
                     case CONNECTED of 2:QueueSerialWrite(#06);        // serial write ACK
                                       4:;  // WriteSocket(#06)                                                        // #################### MISSING ####################
                     end  { of case }
                   end
              else begin
                     S:=VT100engine(ch);                               // first process character into/throught the VT100 engine

                     for I:=1 to length(S) do                          // for everything that comes out the other end...
                     begin                                             // (may be nothing, one, or a string of characters)
                       T:=GFXengine(S[I]);                             // ... process through the GFX engine

                       for J:=1 to length(T) do emit(T[J])             // lastly print out what remains as normal text
                     end
                   end
  end;

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

// ******** update cursor position (the very last thing we do here) ************
  I:=cellH*(min(max(1, Ypos), ROWS)-1);
  if VTcursor.Top<>I then VTcursor.Top:=I;
  I:=cellW* (min(max(1, Xpos), COLS)-1);
  if VTcursor.Left<>I then VTcursor.Left:=I

////////////////////////////////////////////////////////////////
//  the following line ensures that Panel1 always has focus   //
//  when being interacted, and hence that mouse wheel events  //
//  are not disrupted. exceptions are:                        //
//  1. when command window is being interacted with,          //
//  2. the select and copy window (Memo1) is displayed,       //
//  3. the application has not got focus (keyboard input)     //
////////////////////////////////////////////////////////////////
//if not Memo1.Visible then Panel1.SetFocus
{
  if ACTIVATED and not (Memo1.Visible or                               // not text buffer visible (for copying text)
                      Panel1.Focused)                                  // not panel1 is focused
                         then Panel1.SetFocus                          // push focus to panel1         // with Lazarus, this can cause the application to
}                                                                                                      // exhibit an undesirable 'stay on top' behaviour
end;



(*
// process data from ringbuffer to screen
procedure TForm1.Timer2Timer(Sender: TObject);                         // screen ticker                                 ////////////////
var I1, I2:integer;                                                    // 45ms = approx 1/20th sec.                    XXX now 10ms XXX
    S1, S2:str255;                                                     // falls through after 30ms                    ////////////////
      mark:int64;
        ch:char;
//const N:int64=0;
begin
//  writeln('':16, GetTickCount64-N);
//  N:=GetTickCount64;
  mark:=GetTickCount64;

  if SkipCount>0 then dec(SkipCount, Timer2.Interval) else             // brief pause while any dialogs are popped up
  begin                                                                // (this is largely to keep Puppy Linux happy)

//  if Application.ModalLevel>0 then SkipCount:=Timer2.Interval*10;    // skip 10/11 of the time when a modal window is visible - kludge to stop TFontDialog misbehaving

    if ScrollLCK then begin
                        if ((mark mod 500)<250) then begin if Label5.Color<>clLime   then Label5.Color:=clLime   end
                                                 else begin if Label5.Color<>clYellow then Label5.Color:=clYellow end;
                        exit;
                      end
                 else if Label5.Color<>clLime then Label5.Color:=clLime;

    if ScrollTOS then begin
                        if (Ypos>1) then
                        begin
                          scroll(1, 1, COLS, ROWS, 1);
                          dec(Ypos);
                          XYnew:=true
                        end;
                        ScrollTOS:=(Ypos>1);
                        exit
                      end;
                                                                                                                        ////////////////
    while (timesince(mark)<10) and (RxBuffer.head<>RxBuffer.tail) do   // drop out after 30ms maximum                  XXX now 10ms XXX
    begin                                                                                                             ////////////////

      ch:=RxBuffer.data[RxBuffer.tail];
      RxBuffer.tail:=(RxBuffer.tail+1) mod sizeof(RxBuffer.data);

      if ch=#05 then begin                                             // ENQ -> ACK, this NEVER gets processed through VT100 or GFX engines
                       if PasteBuffer.index=0 then                     // ignore ENQ during pasting
                       case CONNECTED of 2:QueueSerialWrite(#06);      // serial write ACK
                                         4:;  // WriteSocket(#06)                                                        // #################### MISSING ####################
                       end  { of case }
                     end
                else begin
                       S1:=VT100engine(ch);                            // first process character into/throught the VT100 engine

                       for I1:=1 to length(S1) do                      // for everything that comes out the other end...
                       begin                                           // (may be nothing, one, or a string of characters)
                         S2:=GFXengine(S1[I1]);                        // ... process through the GFX engine

                         for I2:=1 to length(S2) do emit(S2[I2])       // lastly print out what remains as normal text
                       end
                     end
    end
  end
end;  *)



// handle paste operations
procedure TForm1.Timer3Timer(Sender: TObject);                         // paste ticker (variable)
const skip:byte=0;                                                     // slow paste + CR -> skip a few interrupts
        ch:char=#00;                                                   // last character pasted
var S:str255;
    I:integer;
//const N:int64=0;
begin
//  writeln('':32, GetTickCount64-N);
//  N:=GetTickCount64;
  if (PasteBuffer.index=0) and (Timer3.Interval<>300) then Timer3.Interval:=300;       // idle at 300ms

  if PasteBuffer.index=1 then begin                                    // ######## initialize the paste operation
                                Timer3.Interval:=15;                   // ramp up to 15ms intervals
                                TS5:=GetTickCount64;                   // timestamp start of paste operation
                                TS6:=TS5;                              // finish = start: 0 seconds elapsed
                                TS3:=TS5;                              // force slow paste initially
                                skip:=0;                               // no skipping yet!
                                ch:=#00                                // no 'last' character loaded
                              end;

  if ((PasteBuffer.index<>0) and (CONNECTED=0)) or                     // kill paste operation if suddenly disconnected
     (PasteBuffer.index>PasteBuffer.count) then begin                  // OR we have finished pasting everything in buffer
                                                  PasteBuffer.index:=0;
                                                  PasteBuffer.count:=0;
                                                  PasteBuffer.data:=''
                                                end;

  if (PasteBuffer.index<>0) and (CONNECTED in [2,4]) then             // there is something to paste, and we are connected to something
  begin
    if skip<>0 then dec(skip) else                                    // a previous iteration has requested us to skip some number of interrupts
    begin

      if timesince(TS3)>1000 then                                     // *** fast paste ***
      begin                                                           // ==================
        if timesince(TS1)>180 then CRwait:=0;                         // 180ms timeout on seeing a handshake
                                                                      // ( send <CR>  ->  receive <LF> )
        if CRwait<1 then
        begin
          S:='';
          I:=PasteBuffer.index;
          repeat
            ch:=PasteBuffer.data[I];
            if ch=#13 then inc(CRwait);

            S:=S+ch;
            inc(I)
          until (I>PasteBuffer.count) or (ch<#32) or                  // grab a line up to and incl CR or LF
                (length(S)>=160) or                                   // split lines > 160 characters long
          ((CommRate>120000) and (length(S)>=40));                    // 40 char split at higher baud rates

          case CONNECTED of 2:if QueueSerialWrite(S) then PasteBuffer.index:=I;
                            4:; // if WriteSocket(S) then PasteBuffer.index:=I                                         // #################### MISSING ####################
          end;  { of case }
          TS6:=GetTickCount64
        end
      end

      else                                                             // *** slow paste ***
      begin                                                            // ==================
        if not((ch=#13) and (timesince(TS1)<300)) then
        begin                                                          // 300ms silence req'd after we've sent a <CR>
          ch:=PasteBuffer.data[PasteBuffer.index];
          if ch=#13 then skip:=2;                                      // introduce a 45ms delay after sending a <CR>
                                                                       // to allow the editor to start responding.
//        if ch=#13 then inc(CRwait);                                  // note: editor will not respond to <CR> with anything that makes sense to us,
                                                                       // it will just be a whole string of escape sequences and gobbledygook
//        if ch=#13 then writeln
//                  else write('.');
          case CONNECTED of 2:if QueueSerialWrite(ch) then inc(PasteBuffer.index);
                            4:; // if WriteSocket(ch) then inc(PasteBuffer.index)                                      // #################### MISSING ####################
          end;  { of case }
          TS6:=GetTickCount64
        end
      end
    end
  end
//writeln('active control is: ',TButton(Screen.ActiveControl).Name)
end;



// check for unplugged USB cable, display various error messages
procedure TForm1.Timer4Timer(Sender: TObject);                         // was USB health check, now more used for displaying popup error messages
var temp, info:string;                                                 // 300mS
// const N:int64=0;
begin
//  writeln('':48, GetTickCount64-N);
//  N:=GetTickCount64;
(*
  X:=Image1.ScreenToClient(Mouse.CursorPos).x;                                         // this was originally handled by timer1, but was
  Y:=Image1.ScreenToClient(Mouse.CursorPos).y;                                         // ... causing problems when called too frequently.
  Label8.Visible:=(X>=0) and (Y>=0) and (X<Image1.Width) and (Y<Image1.Height);        // ... here seems to be a safer place to do this.
*)                                                                                     // (no longer used, as Label8 now displays DTR/DSR, RTS/CTS)

  if (CONNECTED=2) and not FileExists(CommName) then
  begin
    temp:=CommName;
    CloseCommPort;
    MessageDlg('GFXterm - Error', #13+pL+'Serial device symlink missing:'+pR+#13+
                                      pL+temp+pR+#13+
                                  #13+
                                      pL+'If you are using a USB to serial bridge,'+pR+#13+
                                      pL+'please check that the USB cable has not'+pR+#13+
                                      pL+'been unplugged.'+pR+#13, mtWarning, [mbOk],0)
  end;

  if ErrorCode<>0 then
  begin
    if SaveDialog1.FileName='' then info:='(filename not specified)'                           // used by errors 6 and 7
                               else info:=SaveDialog1.FileName;

    case ErrorCode of 1:temp:=#13+pL+'Communications Error'+pR+#13+#13+                        // 1 to 5 are serial communications errors
                                  pL+'Failed to open serial port:'+pR+#13+
                                  pL+ErrorPort+pR+#13;
                      2:temp:=#13+pL+'Communications Error'+pR+#13+#13+
                                  pL+'Failed to flush serial port:'+pR+#13+
                                  pL+ErrorPort+pR+#13;
                      3:temp:=#13+pL+'Communications Error'+pR+#13+#13+
                                  pL+'Failed to configure serial port:'+pR+#13+
                                  pL+ErrorPort+pR+#13;
                      4:temp:=#13+pL+'Communications Error'+pR+#13+#13+
                                  pL+'Error reading data from serial port:'+pR+#13+
                                  pL+ErrorPort+pR+#13+#13+
                                  pL+'Connection has been Closed'+pR+#13;
//                                pL+'[ '+SysErrorMessage(ErrorData[1])+' ]'+pR+#13;
                      5:temp:=#13+pL+'Communications Error'+pR+#13+#13+
                                  pL+'Error writing data to serial port:'+pR+#13+
                                  pL+ErrorPort+pR+#13+#13+
                                  pL+'Connection has been Closed'+pR+#13;
//                                pL+'[ '+SysErrorMessage(ErrorData[1])+' ]'+pR+#13;

                      6:temp:=#13+pL+'Failed to Append to existing Log File:'+pR+#13+          // 6 and 7 are errors writing to a log file
                                  pL+SaveDialog1.FileName+pR+#13;
                      7:temp:=#13+pL+'Could not create new Log File:'+pR+#13+
                                  pL+SaveDialog1.FileName+pR+#13;

                      8:temp:=#13+pL+'Selected font size is too small'+pR+#13;                 // 8 and 9 are errors relating to changing font
                      9:temp:=#13+pL+'Selected font size is too large'+pR+#13+#13+
                                  pL+'need: '+ IntToStr(ErrorData[1])+' x '+IntToStr(ErrorData[2])+' pixels'+pR+#13+
                                  pL+'have: '+ IntToStr(ErrorData[3])+' x '+IntToStr(ErrorData[4])+' pixels'+pR+#13;

                     10:begin                                                                  // 10: unable to connect due to serial I/O thread being busy
                          case ErrorData[1] of 1:temp:='Close Device';                         // fpClose (linux), CloseHandle (win32)
                                               2:temp:='Open Device';                          // fpOpen
                                               3:temp:='IO Control';                           // fpIOCtl
                                               4:temp:='Flush Tx Data';                        // tcFlush
                                               5:temp:='Set Attributes';                       // tcSetAttr
                                               6:temp:='Read Data';                            // fpRead (linux), ReadFile (win32)
                                               7:temp:='Write Data';                           // fpWrite (linux), WriteFile (win32)
                                               8:temp:='Check Rx Queue';                       // ClearCommError (win32 only)
                                            else temp:='other'
                          end;  { of case }

                          if ErrorData[2]=ErrorData[3] then info:='' else                      // neither or both (both is impossible)
                          if ErrorData[2]=ord(true)    then info:='(Serial Receive) ' else     // RxBusy
                          if ErrorData[3]=ord(true)    then info:='(Serial Transmit) ' else    // TxBusy
                                                            info:='';                          // neither

                          temp:=#13+pL+'Communications System '+info+'is Busy'+pR+#13+#13+
                                    pL+'Waiting on function:  '+temp+pR+#13+
//                                  pL+'thread delay = '+IntToStr(timesince(TS7) div 1000)+'s'+pR+#13+#13+
                                    pL+'Please wait 30 seconds, then try again'+pR+#13
                        end;
//                   11:temp:=pL+'Invalid Number of Decimal Digits Entered'+pR+#13+#13+        // 11: invalid escape sequence entered by user
//                            pL+'Only  /d,  /dd,  or  /ddd  are valid,'+pR+#13+
//                            pL+'or enter  //  for a single  /  character'+pR+#13

                     11:temp:=#13+pL+'Missing Decimal Digit(s) following  "/"  Character'+pR+#13+#13+
                                  pL+'Enter  //  if a single  /  character is required,'+pR+#13+
                                  pL+'otherwise there must be at least ONE decimal'+pR+#13+
                                  pL+'digit after each  /  character.  Any digits beyond'+pR+#13+
                                  pL+'the 3rd are treated as plain text.'+pR+#13

                   else temp:=#13+pL+'An unknown error ('+IntToStr(ErrorCode)+') has occured'+pR+#13+
                                  pL+'data : '+IntToStr(ErrorData[1])+', '+IntToStr(ErrorData[2])+
                                          ', '+IntToStr(ErrorData[3])+', '+IntToStr(ErrorData[4])+pR+#13
    end;  { of case }

    ErrorCode:=0;
    ErrorPort:='';
    fillchar(ErrorData, sizeof(ErrorData), #0);
    MessageDlg('GFXterm - Error', temp, mtWarning, [mbOk],0)
  end
end;






////////////////////////////////////////////////////////////////////////////////
// Keyboard and Mouse Events
// =========================
////////////////////////////////////////////////////////////////////////////////

// *** handle normal ascii keys ***
procedure TForm1.FormKeyPress(Sender: TObject; var Key: char);
begin
  if Memo1.Visible then exit;                  // ignore keys if select/cut text buffer visible
//windows.beep(880,50);

  lastK:=Key;
  if PasteBuffer.index=0 then case CONNECTED of 0:begin
                                                    if not (Key in [#00..#06, #14..#31]) then emit(Key) else   // null (#00) can never lands here, it is instead
                                                    begin                                                      // handled in TForm1.FormKeyDown as a special case
                                                      emit('<');
                                                      emit(chr(ord('0')+(ord(Key) div 10)));
                                                      emit(chr(ord('0')+(ord(Key) mod 10)));
                                                      emit('>')
                                                    end;
                                                    TS1:=GetTickCount64;
                                                    TS2:=TS1
                                                  end;
                                                2:QueueSerialWrite(Key);
                                                4:; // WriteSocket(Key)                                                // #################### MISSING ####################
                              end  { of case }
end;



// *** handle special keys that need to be auto-repeating ***
procedure TForm1.FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
var S:string;
    I:integer;
begin
  TS8:=GetTickCount64;
  if Memo1.Visible then exit;                                          // ignore keys if select/cut text buffer visible
//windows.beep(880,50);

  S:='';

  if not (ssAlt in Shift) then                                         // exclude alt- versions
  case Key of VK_UP:S:=#27+'[A';
            VK_DOWN:S:=#27+'[B';
           VK_RIGHT:S:=#27+'[C';
            VK_LEFT:S:=#27+'[D';

            VK_HOME:S:=#27+'[1~';
          VK_INSERT:S:=#27+'[2~';
//        VK_DELETE:S:=#27+'[3~';                                      // VT220 sequence for the delete key
             VK_END:S:=#27+'[4~';
           VK_PRIOR:S:=#27+'[5~';
            VK_NEXT:S:=#27+'[6~';

             VK_TAB:begin S:=#09; lastK:=#09 end;                      // map tab key to chr(9)
          VK_DELETE:begin S:=#127; lastK:=#127 end;                    // VT102 delete key -> chr(127)
             VK_F10:Key:=0;                                            // WINDOWS: supress f10 popping up right-click menu (seems to do no harm under Linux)
          VK_SCROLL:Key:=0;                                            // supress scroll-lock key, so it doesn't generating ctrl-T. scroll-lock state still toggles
          VK_ESCAPE:;  // if NetworkSearching then NetworkErrorFlag:=true
                       // kludge to escape from loop while connecting                                                  // #################### MISSING ####################
  end;  { of case }

  if (ssCtrl in Shift) and (Key=VK_RETURN) then begin S:=#10; lastK:=#10 end;      // ctrl-enter -> lf (windows seems to do this mapping internally)
  if (ssAlt in Shift) and (Key=VK_RETURN) then begin S:=#13#10; lastK:=#255 end;   // alt-enter -> cr+lf, 255 codes "\n"
  if (ssCtrl in Shift) and (Key=ord('0')) then begin S:=#00; lastK:=#00 end;       // ctrl-0 -> nul
  if (ssAlt in Shift) and (Key=ord('0')) then begin S:=#00; lastK:=#00 end;        // alt-0 -> nul (depreciated, but kept in for nostalgia)

  if length(S)<>0 then Key:=0;                                         // supress handled keys from being passed on to Form1.OnKeyPress handler

  if (PasteBuffer.index=0) and (length(S)>0) then
  case CONNECTED of 0:begin
                        if S[1]=#27 then S:=' esc'+'"'+S+'" ';
                        if S[1]=#00 then S:='<00>';                    // special case of ctrl-0 or alt-0
                        for I:=1 to length(S) do emit(S[I])
                      end;
                    2:QueueSerialWrite(S);
                    4:; // WriteSocket(S)                                                                              // #################### MISSING ####################
  end  { of case }
end;



// *** handle non-repeating keys upon release ***
procedure TForm1.FormKeyUp(Sender: TObject; var Key: Word; Shift: TShiftState);
var S, T:string;
    I, N:integer;
{$IFNDEF WINDOWS}
const RTS_flag:integer=TIOCM_RTS;
      DTR_flag:integer=TIOCM_DTR;
{$ENDIF}
begin
  TS8:=GetTickCount64;
  if Memo1.Visible then                                                // ignore keys if select/cut text buffer visible
  begin
    if (Key=13) or (Key=27) then                                       // EXCEPT hide Memo1 on ESC or CR
    begin
      Memo1.Lines.Clear;
      Memo1.Enabled:=false;                                            // probably not needed
      Memo1.Visible:=false;

      Memo1.Width:=94;                                                 // shrink down to designtime size to avoid
      Memo1.Height:=90;                                                // any problems if font size is changed

      Form1.PopupMenu:=PopupMenu1                                      // re-enable our popup menu
//    Form1.SetFocus
    end;
    exit
  end;
//windows.beep(880,50);

// ssShift	The Shift key is held down.
// ssAlt	The Alt key is held down.
// ssCtrl	The Ctrl key is held down.

  S:='';                                                               // default action: do nothing

  if Key=VK_SCROLL then ScrollLCK:=not ScrollLCK;                      // pause screen scrolling (toggles, same as alt-8 below)

// *** shifted and unshifted function keys ***
  if not (ssAlt in Shift) and not (ssCtrl in Shift) then               // disallow alt and ctrl
  if ssShift in Shift
  then case Key of VK_F3:S:=#27+'[25~';                                // shifted function keys (maps to F13 onwards)
                   VK_F4:S:=#27+'[26~';
                   VK_F5:S:=#27+'[28~';
                   VK_F6:S:=#27+'[29~';
                   VK_F7:S:=#27+'[31~';
                   VK_F8:S:=#27+'[32~';
                   VK_F9:S:=#27+'[33~';
                  VK_F10:S:=#27+'[34~'
       end  { of case }
  else case Key of VK_F1:S:=#27+'[11~';                                // unshifted function keys
                   VK_F2:S:=#27+'[12~';
                   VK_F3:S:=#27+'[13~';
                   VK_F4:S:=#27+'[14~';
                   VK_F5:S:=#27+'[15~';
                   VK_F6:S:=#27+'[17~';
                   VK_F7:S:=#27+'[18~';
                   VK_F8:S:=#27+'[19~';
                   VK_F9:S:=#27+'[20~';
                  VK_F10:S:=#27+'[21~';
                  VK_F11:S:=#27+'[23~';
                  VK_F12:S:=#27+'[24~'
       end;  { of case }

// *** alt keys (letters and numbers), these are all 'special' commands ***
  if (ssAlt in Shift) and not (ssCtrl in Shift) and not (ssShift in Shift) then
  begin
    case Key of ord('B'):{$IFDEF WINDOWS}
                         BreakCounter:=0;                              // try to reset micromite
                         {$ELSE}
                         if CONNECTED=2 then try tcSendBreak(SerialHandle, 0) except end;
                         {$ENDIF}
//              ord(' '):if CONNECTED=2 then CloseCommPort                                     // linux/XFCE hooks alt-space, so we have to use ctrl-space instead   :-(
//                                      else if LastPort<>'' then MenuItem1AClick(nil);        //     (see alternative code approx 115 lines further down)
                ord('P'):MenuItem4A1and2Click(MenuItem4A1);
                ord('C'):begin
                           GFXclear(0, 0, Gw, Gh);                     // clear graphics layer
                           Image2.Hide                                 // hide graphics layer
                         end;
                ord('D'):clear(1, 1, COLS, ROWS);                      // clear text layer
                ord('Z'):if PasteBuffer.index<>0 then
                         begin                                         // cancel paste
                           PasteBuffer.index:=0;
                           PasteBuffer.count:=0;
                           PasteBuffer.data:=''
                         end;
                ord('A'):RxBuffer.tail:=RxBuffer.head;                 // clear ring buffer
                ord('L'):if LOGTOFILE then begin                       // stop logging
                                             LOGTOFILE:=false;
                                             try Flush(LogFile) except end;
                                             try CloseFile(LogFile) except end
                                           end
                                      else if SaveDialog1.FileName<>'' then
                                           try                         // resume logging
                                             Append(LogFile);
                                             LOGTOFILE:=true
                                           except
                                             LOGTOFILE:=false;
                                             try Flush(LogFile) except end;
                                             try CloseFile(LogFile) except end;
                                             ErrorCode:=6
                                           end;
                ord('R'):ResetTerminal(0);                             // reset whole terminal system
                ord('U'):CursorVis:=not CursorVis;                     // toggle cursor visible/hidden

                ord('M'):PopupMenu1.Popup(Mouse.CursorPos.x, Mouse.CursorPos.Y);

{$IFDEF WINDOWS}
                ord('1'):if CONNECTED=2 then try EscapeCommFunction(SerialHandle, SETDTR) except end;          // set DTR
                ord('2'):if CONNECTED=2 then try EscapeCommFunction(SerialHandle, CLRDTR) except end;          // clear DTR
                ord('3'):if CONNECTED=2 then try EscapeCommFunction(SerialHandle, SETRTS) except end;          // set RTS
                ord('4'):if CONNECTED=2 then try EscapeCommFunction(SerialHandle, CLRRTS) except end;          // clesr RTS
{$ELSE}
                ord('1'):if CONNECTED=2 then try FpIOCtl(SerialHandle, TIOCMBIS, @DTR_flag) except end;        // set DTR
                ord('2'):if CONNECTED=2 then try FpIOCtl(SerialHandle, TIOCMBIC, @DTR_flag) except end;        // clear DTR
                ord('3'):if CONNECTED=2 then try FpIOCtl(SerialHandle, TIOCMBIS, @RTS_flag) except end;        // set RTS
                ord('4'):if CONNECTED=2 then try FpIOCtl(SerialHandle, TIOCMBIC, @RTS_flag) except end;        // clesr RTS
{$ENDIF}
         VK_UP, ord('6'):if not ScrollLCK then ScrollTOS:=true;                // ^ = scroll prompt to top of screen (also map to alt-UP)
                ord('7'):begin
                           flagPOPUP:=true;
                           if InputQuery('Control String Input',
                                         'Enter control codes in Decimal as  /d,  /dd,  or  /ddd.  //  translates to  /'+#13+
                                         ' ', S) then
                           begin
                             T:='';
                             while length(S)<>0 do
                             begin
                               if S[1]<>'/' then begin                                   // starts with anything other than '/'
                                                   T:=T+S[1];
                                                   delete(S, 1, 1)
                                                 end
                                            else if pos('//',S)=1 then begin             // starts with '//' (escape sequence for '/'
                                                                         T:=T+S[1];
                                                                         delete(S, 1, 2)
                                                                       end
                                                                  else begin             // starts with '/n[n[n]]' where n are digits in ['0'..'9']
                                                                         I:=0;
                                                                         while (length(S)>(I+1)) and (S[I+2] in ['0'..'9']) do inc(I);
                                                                         I:=min(I, 3);                              // ignore digits beyond the 3rd
                                                                         if I in [1..3] then begin
                                                                                               N:=StrToInt(copy(S, 2, I));
                                                                                               T:=T+chr(N);
                                                                                               delete(S, 1, I+1)
                                                                                             end
                                                                                        else begin
                                                                                                S:='';
                                                                                                T:='';
                                                                                                ErrorCode:=11
                                                                                              end
                                                                       end
                             end;
                             S:=T
                           end;
                           flagPOPUP:=false
                         end;
                ord('8'):ScrollLCK:=not ScrollLCK;                     // pause screen scrolling (toggles)
            VK_LCL_COMMA:begin                                         // the ",<" key
                           BELLvolume:=max(BELLvolume-5, 0);
                           Panel2.Left:=(Panel1.Width-Panel2.Width) div 2;
                           Panel2.Top:=(Panel1.Height-Panel2.Height) div 2;
                           Label9.Caption:='BELL volume:'+#13+
                                           StringOfChar('|',(BELLvolume div 5))+
                                           StringOfChar('-',20-(BELLvolume div 5));
                           Panel2.Show;
                           Panel2.Tag:=3000;                           // hide after 3 seconds
                           BELL:=1
                         end;
            VK_LCL_POINT:begin                                         // the ".>" key
                           BELLvolume:=min(BELLvolume+5, 100);
                           Panel2.Left:=(Panel1.Width-Panel2.Width) div 2;
                           Panel2.Top:=(Panel1.Height-Panel2.Height) div 2;
                           Label9.Caption:='BELL volume:'+#13+
                                           StringOfChar('|',(BELLvolume div 5))+
                                           StringOfChar('-',20-(BELLvolume div 5));
                           Panel2.Show;
                           Panel2.Tag:=3000;                           // hide after 3 seconds
                           BELL:=1
                         end
    end  { of case }                                                   // don't try using alt-0 in here, as it is now used
  end;                                                                 // to generate null in the Form1.OnKeyDown handler

// ######################################################################
// the following key actions are for testing purposes only. there is NO
// guarantee that any given function will remain the same, or be present,
// between different releases of GFXterm.
// ######################################################################

// *** ctrl-n (numbers only) ***
  if (ssCtrl in Shift) and not (ssAlt in Shift) and not (ssShift in Shift) then
  begin
    case Key of ord(' '):if CONNECTED=2 then CloseCommPort             // ctrl-space   toggle connection - linux/XFCE hooks alt-space, so we have to use ctrl-space instead   :-(
                                        else MenuItem1AClick(nil);
                ord('1'):begin                                         // ctrl-1   toggle double buffering
                           Panel1.DoubleBuffered:=not Panel1.DoubleBuffered;
                           if Panel1.DoubleBuffered then ShowMessage(#13+pL+'Double Buffering is ON'+pR+#13)
                                                    else ShowMessage(#13+pL+'Double Buffering is OFF'+pR+#13)
                         end;
                ord('2'):begin                                         // ctrl-2   toggle lamp test
                           LABELTEST:=not LABELTEST;
                           if LABELTEST then ShowMessage(#13+pL+'lamp test is ON'+pR+#13)
                                        else ShowMessage(#13+pL+'lamp test is OFF'+pR+#13)
                         end;
// note - under linux ctrl-3 to ctrl-7 produce control codes 0x1B-0x1F respectively, making these unavailable as special functions
//                    ~~~~~~    ~~~~~~                       ~~~~~~~~~
(*              ord('4'):begin                                         // ctrl-4                                       // #################### MISSING ####################
                           if CONNECTED=4 then CONNECTED:=0;
//                           try ClientSocket1.Close except end; // force network disconnect
//                           ShowMessage(#13+pL+'Client Socket has been CLOSED'+pR+#13)
                         end;  *)
                ord('8'):begin                                         // ctrl-8   display font, event timing, and serial port information
                           I:=max(0, TS6-TS5);
                           S:=#13+pL+VTcursor.Font.Name+pR+#13+#13;
//                         S:=S+pad(12,'FontIndex = '+IntToStr(FontIndex))+#13;
//                         if VTcursor.AutoSize then S:=S+pad(12,'AutoSize = ON')+#13
//                                              else S:=S+pad(12,'(AutoSize = OFF')+#13;
                           S:=S+pL+'('+IntToStr(VTcursor.Width)+' x '+IntToStr(VTcursor.Height)+')'+pR+#13;
                           if CONNECTED<>0 then
                               S:=S+#13+pL+'connected for '+DHMStime(timesince(TS4))+pR+#13+
                                        pL+'last RxD was '+DHMStime(timesince(TS1))+' ago'+pR+#13+
                                        pL+'last TxD was '+DHMStime(timesince(TS2))+' ago'+pR+#13+
                                    #13+
                                        pL+'last paste took '+IntToStr(I div 1000)+'.'
                                                             +IntToStr((I mod 1000) div 100)
                                                             +' seconds'+pR+#13;
{$IFNDEF WINDOWS}
                           if CONNECTED=2 then S:=S+#13+pL+'TTYname :  '+TTYname(SerialHandle)+pR+#13;
{$ENDIF}
                           ShowMessage(S);
                           S:=''
                         end;
//              ord('9'):MessageBeep(MB_OK)
//              ord('9'):try fpClose(SerialHandle) except end          // ctrl-9   forced close of serial port
//              ord('9'):SerialToIdle:=not SerialToIdle                //          suspend reading from (and writing to) serial port
    end  { of case }
  end;

  if (PasteBuffer.index=0) and (length(S)>0) then
  case CONNECTED of 0:begin
                        if S[1]=#27 then S:=' esc'+'"'+S+'" ';
                        for I:=1 to length(S) do emit(S[I])
                      end;
                    2:QueueSerialWrite(S);
                    4:; // WriteSocket(S)                                                                              // #################### MISSING ####################
  end  { of case }
end;






////////////////////////////
// mouse movement events ///
////////////////////////////

// *** MOUSE MOVE ***
procedure TForm1.Panel1MouseMove(Sender: TObject; Shift: TShiftState; X, Y: Integer);
begin
  if Sender=VTcursor then begin
                            MouseX:=min(Xpos, COLS);                   // fix: can be =81 if at end of line
                            MouseY:=Ypos
                          end else
   if sender=Panel1  then begin
                            MouseX:=(X div cellW)+1;                   //  was: trunc((X/cellW)+1);
                            MouseY:=(Y div cellH)+1;                   //  was: trunc((Y/cellH)+1)
                          end
                     else WriteLn('WARNING: unexpected mouse move event from '+TButton(Sender).Name)
//write(MouseX:8, MouseY:8);
//if sender=VTcursor then writeln('*':8)
//                   else writeln
end;



// *** MOUSE DOWN ***
procedure TForm1.Panel1MouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
var flags:byte;
        S:string;
begin
  if (CONNECTED in [2,4]) and (MouseMode>0) and (Button=mbLeft) and (PasteBuffer.index=0) then
  begin
    if sender=VTcursor then begin
                               MouseX:=min(Xpos, COLS);                // fix: can be =81 if at end of line
                               MouseY:=Ypos
                             end else
    if sender=Panel1    then begin
                               MouseX:=(X div cellW)+1;                //  was: trunc((X/cellW)+1);
                               MouseY:=(Y div cellH)+1;                //  was: trunc((Y/cellH)+1)
                             end
                        else WriteLn('WARNING: unexpected mouse down event from '+TButton(Sender).Name);

//  if sender=VTcursor then writeln('mouse down', '*':14)
//                     else writeln('mouse down');

//  ShowMessage(IntToStr(MouseX)+','+IntToStr(MouseY))
    if (MouseX>=1) and (MouseX<=COLS) and (MouseY>=1) and (MouseY<=ROWS) then
    begin
      flags:=0;
      if ssShift in Shift then inc(flags, 4);
      if ssAlt in Shift then inc(flags, 8);
      if ssCtrl in Shift then inc(flags, 16);

      case MouseMode of $0001:S:=#27+'[M '+chr(32+MouseX)+chr(32+MouseY);                  // X10
                        $0101:S:=#27+'[<0;'+IntToStr(MouseX)+';'+IntToStr(MouseY)+'M';     // X10/SGR
                        $1001:S:=#27+'[32;'+IntToStr(MouseX)+';'+IntToStr(MouseY)+'M';     // X10/URXVT

                        $0010:S:=#27+'[M'+chr(32+flags)+chr(32+MouseX)+chr(32+MouseY);                     // VT200
                        $0110:S:=#27+'[<'+IntToStr(flags)+';'+IntToStr(MouseX)+';'+IntToStr(MouseY)+'M';   // VT200/SGR
                        $1010:S:=#27+'['+IntToStr(32+flags)+';'+IntToStr(MouseX)+';'+IntToStr(MouseY)+'M'  // VT200/URXVT
                     else S:=''
      end ; { of case }

      if (PasteBuffer.index=0) and (length(S)>0) then
      case CONNECTED of 2:QueueSerialWrite(S);
                        4:; // WriteSocket(S)                                                                          // #################### MISSING ####################
      end  { of case }
    end
  end
end;



/// *** MOUSE UP ***
procedure TForm1.Panel1MouseUp(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
var flags:byte;
        S:string;
begin
  if (CONNECTED in [2,4]) and (MouseMode>0) and (Button=mbLeft) and (PasteBuffer.index=0) then
  begin
    if sender=VTcursor then begin
                               MouseX:=min(Xpos, COLS);                // fix: can be =81 if at end of line
                               MouseY:=Ypos
                            end else
    if sender=Panel1   then begin
                              MouseX:=(X div cellW)+1;                 //  was: trunc((X/cellW)+1);
                              MouseY:=(Y div cellH)+1;                 //  was: trunc((Y/cellH)+1)
                            end
                       else WriteLn('WARNING: unexpected mouse up event from '+TButton(Sender).Name);

//  if sender=VTcursor then writeln('mouse up', '*':16)
//                     else writeln('mouse up');

//  ShowMessage(IntToStr(MouseX)+','+IntToStr(MouseY))
    if (MouseX>=1) and (MouseX<=COLS) and (MouseY>=1) and (MouseY<=ROWS) then
    begin
      flags:=0;
      if ssShift in Shift then inc(flags, 4);
      if ssAlt in Shift then inc(flags, 8);
      if ssCtrl in Shift then inc(flags, 16);

      case MouseMode of $0010:S:=#27+'[M'+chr(32+3+flags)+chr(32+MouseX)+chr(32+MouseY);                       // VT200
                        $0110:S:=#27+'[<'+IntToStr(flags)+';'+IntToStr(MouseX)+';'+IntToStr(MouseY)+'m';       // VT200/SGR
                        $1010:S:=#27+'['+IntToStr(32+3+flags)+';'+IntToStr(MouseX)+';'+IntToStr(MouseY)+'M'    // VT200/URXVT
                     else S:=''
      end ; { of case }

      if (PasteBuffer.index=0) and (length(S)>0) then
      case CONNECTED of 2:QueueSerialWrite(S);
                        4:; // WriteSocket(S)                                                                          // #################### MISSING ####################
      end  { of case }
    end
  end
end;



// *** MOUSE WHEEL ***
procedure TForm1.FormMouseWheel(Sender: TObject; Shift: TShiftState;
  WheelDelta: Integer; MousePos: TPoint; var Handled: Boolean);
var S:string;
begin
  if Memo1.Visible then exit;                                          // ignore mouse wheel if select/cut text buffer visible

  if ssShift in Shift then begin                                               // (shifted)
                             if WheelDelta>0 then S:=#27+'[D' else             // cursor left
                             if WheelDelta<0 then S:=#27+'[C' else S:=''       // cursor right
                           end
                      else begin                                               // (unshifted)
                             if WheelDelta>0 then S:=#27+'[A' else             // cursor up
                             if WheelDelta<0 then S:=#27+'[B' else S:=''       // cursor down
                           end;

  if (PasteBuffer.index=0) and (length(S)>0) then
  case CONNECTED of 2:QueueSerialWrite(S);
                    4:; // WriteSocket(S)                                                                              // #################### MISSING ####################
  end; { of case }
//windows.beep(880,50);
  Handled:=true
end;






////////////////////////////////
// right-click menu controls ///
////////////////////////////////

// customise menu before it pops up
procedure TForm1.PopupMenu1Popup(Sender: TObject);
begin
  MenuItem1A.Visible:=(CONNECTED=0);
  MenuItem1B.Visible:=(CONNECTED<>0);
  MenuItem2A.Visible:=not LOGTOFILE;
  MenuItem2B.Visible:=LOGTOFILE;
  MenuItem4A.Visible:=(PasteBuffer.index=0);
  MenuItem4B.Visible:=(PasteBuffer.index<>0)
end;



// popup menu item - connect
procedure TForm1.MenuItem1AClick(Sender: TObject);
var OK:boolean;
     I:integer;
     f:Tform3;
begin
//SetupCommPort('/dev/ttyACM0', 38400, 8, 0, 1);
  I:=LCFn;
  if (timesince(TS7)>300) then begin ErrorData[1]:=I;
                                     ErrorData[2]:=ord(RxBusy);
                                     ErrorData[3]:=ord(TxBusy);
                                     ErrorCode:=10
                               end
                          else

  begin
    if (LastName='') or (LastRate=0) then begin
                                            PortName:='';
                                            PortRate:=0;
                                            LastName:='';
                                            LastRate:=0
                                          end
                                     else begin
                                            PortName:=LastName;
                                            PortRate:=LastRate
                                          end;

    if (Sender=nil) and (PortName<>'') then begin
                                              LastName:='';            // if we can't connect, this ensures the last connection details are
                                              LastRate:=0;             // erased, so that the next 'ctrl-space' calls up the connect dialog
                                              OK:=true                 //                     ^^^^
                                            end
                                       else begin
                                              f:=TForm3.Create(nil);
                                              try
                                                flagPOPUP:=true;
                                                OK:=(f.ShowModal=mrOK)
                                              finally
                                                flagPOPUP:=false;
                                                f.Release
                                              end
                                            end;

    if OK then SetupCommPort(PortName, PortRate, 8, 0, 1)
  end
end;



// popup menu item - disconnect
procedure TForm1.MenuItem1BClick(Sender: TObject);
begin
  case Connected of 2:CloseCommPort;
                    4:;                                                                                                // #################### MISSING ####################
  end
end;



// popup menu item - log to file
procedure TForm1.MenuItem2AClick(Sender: TObject);                     // should only be able to enter here with LOGTOFILE set false
begin
  if SaveDialog1.Execute then
  try
//  writeln('rewriting log file');                                     // SaveDialog1 has returned, should have a valid filename
    AssignFile(LogFile, SaveDialog1.Filename);
    ReWrite(LogFile);
    LOGTOFILE:=true                                                    // if we arrive here we can set LOGTOFILE true
  except
//  writeln('exception rewriting');                                    // exception - error occurred while rewriting file
    LOGTOFILE:=false;                                                  // just in case!
    try Flush(LogFile) except end;
    try CloseFile(LogFile) except end;
    ErrorCode:=7
  end
//writeln('<', SaveDialog1.Filename, '>')                              // check filename looks right
end;



// popup menu item - stop logging
procedure TForm1.MenuItem2BClick(Sender: TObject);
begin
  LOGTOFILE:=false;
  try Flush(LogFile) except end;
  try CloseFile(LogFile) except end
end;



// popup menu item - show 'select and copy' edit box
procedure TForm1.MenuItem3Click(Sender: TObject);
var X, Y:integer;
       S:string;
//    TR:TRect;
begin
  Memo1.Width:=cellW*COLS;
  Memo1.Height:=cellH*ROWS;

  Memo1.Font:=VTcursor.Font;
  Memo1.Font.Style:=[];
  Memo1.Font.Color:=clBlack;                                           // black text on a
  Memo1.Color:=clSilver;                                               // silver background

  Memo1.Lines.Clear;                                                   // ensure memo is completely blank

  for Y:=1 to ROWS do                                                  // fill in memo text
  begin
    S:=StringOfChar(' ', COLS);                                        // blank line of 80 chars
    for X:=1 to COLS do
    begin
      S[X]:=TextStore[Y, X];                                           // copy text from buffer (TextStore)
      if S[X]<' ' then S[X]:=' '                                       // turn any control chars into whitespace
    end;                                                               // ... (although there should be none)
    S:=TrimRight(S);
    Memo1.Lines.Add(S)                                                 // transfer completed line into memo
  end;

  S:=Memo1.Text;

{$IFDEF WINDOWS}
  S:=copy(S, 1, length(S)-2);                                          // remove final CR-LF from memo      (WIN32)
{$ELSE}
  S:=copy(S, 1, length(S)-1);                                          // remove final linefeed from memo   (Linux)
{$ENDIF}

  Memo1.Text:=S;

//  TR:=Memo1.ClientRect;                                              // get rid of
//  SendMessage(Memo1.Handle, EM_SETRECT, 0, integer(@TR));            // those pesky
//  Memo1.Invalidate;                                                  // margins!!!
//  above lines are win32-specific, and possibly are not needed anyway for a borderless TMemo

  Form1.PopupMenu:=nil;                                                // disable our popup menu
                                                                       // (cut/copy menu takes over)
  Memo1.Enabled:=true;
  Memo1.Visible:=true
end;



// popup menu item - paste from clipboard or file
procedure TForm1.MenuItem4A1and2Click(Sender: TObject);
var SL:TStringList;
     S:string;
     I:integer;
begin
  if PasteBuffer.index<>0 then exit;

// setup for paste from clipboard
  if Sender=MenuItem4A1 then if ClipBoard.HasFormat(CF_TEXT) then
                             try
                               S:=ClipBoard.AsText;
                             except
                               S:=''
//                             ShowMessage('ClipBoard exception')
                             end;

// setup for paste from text file
  if Sender=MenuItem4A2 then if OpenDialog1.Execute then
                             begin
                               SL:=TStringlist.Create;
                               try
                                 SL.LoadFromFile(OpenDialog1.Filename);
                                 S:=SL.Text
                               except
                                 S:=''
//                               ShowMessage('LoadFromFile exception')
                               end;
                               SL.Free
                             end;

// common code for both types of paste (from clipboard and from text file)

  for I:=1 to length(S) do                                             // clear bit-7 of all characters being pasted
        S[I]:=char(byte(S[I]) and $7F);

  I:=pos(#13#10, S);
  while I<>0 do
  begin                                                                // translate all CR-LF pairs into single CR
    delete(S, I+1, 1);
    I:=pos(#13#10, S)
  end;

  for I:=1 to length(S) do                                             // translate any remaining LFs into CRs
      if S[I]=#10 then S[I]:=#13;

  for I:=length(S) downto 1 do                                         // remove any other control characters (just keeping TAB, CR and crtl-Z)
      if not (S[I] in [#9, #13, #26, #32..#255]) then delete(S, I, 1);

  I:=pos(#32#13, S);
  while I<>0 do
  begin                                                                // remove all trailing spaces at ends of lines
    delete(S, I, 1);
    I:=pos(#32#13, S)
  end;

  while (length(S)<>0) and (S[length(S)]=#32) do delete(S, length(S), 1);
                                                                       // remove final trailing spaces at end of S
(*
  for I:=1 to length(S) do                                             // translate all CRs into LFs as
      if S[I]=#13 then S[I]:=#10;                                      // test for unix formatted files
*)
(*
  for I:=1 to length(S) do                                             // set bit-7 of all characters being pasted
      S[I]:=char(byte(S[I]) or $80);                                   // test for ignoring bit-7 set
*)

  if length(S)<>0 then
  begin
    PasteBuffer.data:=S;                                               // load data into string ready to be streamed
    PasteBuffer.count:=length(S);                                      // out of the comm port by a timer interrupt
    PasteBuffer.index:=1                                               // setting index to 1 kicks off paste...
  end
end;



// popup menu item - cancel pasting
procedure TForm1.MenuItem4BClick(Sender: TObject);
begin
  if PasteBuffer.index<>0 then
  begin
    PasteBuffer.index:=0;
    PasteBuffer.count:=0;
    PasteBuffer.data:=''
  end
end;

(*
// popup menu item - select screen font and size                                                                       // #################################################
procedure TForm1.MenuItem5Click(Sender: TObject);                                                                      // ############### delete when ready ###############
var oldW, oldH,                                // width and height upon entry                                          // #################################################
    newW, newH,                                // with and height with new font
    maxW, maxH,                                // width and height when maximized
    oldT, oldL:integer;                        // top and left upon entry
            OK:boolean;
begin
  Timer1.Enabled:=false;
  Timer2.Enabled:=false;
  Timer3.Enabled:=false;
  Timer4.Enabled:=false;
  Application.ProcessMessages;

  FontDiaLog1.Font:=VTcursor.Font;             // load current font into font selection dialog
  Memo1.Font:=VTcursor.Font;                   // save font details in case we need to back out
  OK:=false;

  if FontDialog1.Execute then
  begin
    oldL:=Form1.Left;
    oldT:=Form1.Top;
    oldW:=Form1.Width;
    oldH:=Form1.Height;

    VTcursor.Left:=0;
    VTcursor.Top:=0;
    VTcursor.Font:=FontDialog1.Font;
    VTcursor.Font.Style:=[];
    VTcursor.Font.Color:=clRed;
    VTcursor.Visible:=true;                    // need cursor to be visible for size to be updated!
    Application.ProcessMessages;
    VTcursor.Visible:=false;                   // can now hide cursor as size has been updated

    if VTcursor.Width<8 then ShowMessage(#13+pL+'Selected font size is too small'+pR+#13) else
    begin
      newW:=Form1.Width -Image1.Picture.Bitmap.Width +(VTcursor.Width *COLS);  // new form target width
      newH:=Form1.Height-Image1.Picture.Bitmap.Height+(VTcursor.Height*ROWS);  // new form target height

////////////////////////////////////////////////////////////////////////////////

      SIZELOCK:=false;                                         // ### ENABLE RESIZING
      Form1.Constraints.MinWidth:=0;
      Form1.Constraints.MaxWidth:=0;
      Form1.Constraints.MinHeight:=0;
      Form1.Constraints.MaxHeight:=0;
//    Form1.BorderIcons:=Form1.BorderIcons+[biMaximize];
      Application.ProcessMessages;

      Form1.AutoSize:=false;                                   // turn off autosizing of the form
//    Form1.BorderStyle:=bsSizeable;                           // needed to allow us to resize under program control
      Form1.WindowState:=wsMaximized;                          // make form the size of the whole screen

      I64:=GetTickCount64+1000;
      repeat
        Application.ProcessMessages;                           // *** ACTION the above changes
        sleep(50)                                              // ... repeating until window changes or timeout
      until (oldW<>Form1.Width) or (oldH<>Form1.Height) or (GetTickCount64>I64);

      maxW:=Form1.Width;                                       // update the maximum width and height values
      maxH:=Form1.Height;

      Form1.AutoSize:=true;                                    // restore window state
      Form1.WindowState:=wsNormal;
      Form1.Left:=oldL;
      Form1.Top:=oldT;

      I64:=GetTickCount64+1000;
      repeat
        Application.ProcessMessages;                           // *** ACTION the above changes
        sleep(50)                                              // ... repeating until window changes or timeout
      until (maxW<>Form1.Width) or (maxH<>Form1.Height) or (GetTickCount64>I64);

      Form1.Constraints.MinWidth:=Form1.Width;
      Form1.Constraints.MaxWidth:=Form1.Width;
      Form1.Constraints.MinHeight:=Form1.Height;
      Form1.Constraints.MaxHeight:=Form1.Height;
//    Form1.BorderIcons:=Form1.BorderIcons-[biMaximize];
      SIZELOCK:=true;                                          // ### DISABLE RESIZING

////////////////////////////////////////////////////////////////////////////////

      if (newW>maxW) or (newH>maxH) then ShowMessage(#13+pL+'Selected font size is too large'+pR+#13+#13+
                                                         pL+'need: '+ IntToStr(newW)+' x '+IntToStr(newH)+' pixels'+pR+#13+
                                                         pL+'have: '+ IntToStr(maxW)+' x '+IntToStr(maxH)+' pixels'+pR+#13) else
      begin
        // *** GOOD TO GO! ***
        Form1.Left:=0;                                         // move form to top left of screen
        Form1.Top:=0;

        SIZELOCK:=false;                                       // ### ENABLE RESIZING
        Form1.Constraints.MinWidth:=0;
        Form1.Constraints.MaxWidth:=0;
        Form1.Constraints.MinHeight:=0;
        Form1.Constraints.MaxHeight:=0;
//      Form1.BorderIcons:=Form1.BorderIcons+[biMaximize];
        Application.ProcessMessages;

        Form1.AutoSize:=false;                                 // turn off autosizing of the form
//      Form1.BorderStyle:=bsSizeable;                         // needed to allow us to resize under program control
        Form1.WindowState:=wsMaximized;                        // make form the size of the whole screen

        I64:=GetTickCount64+1000;
        repeat
          Application.ProcessMessages;                         // *** ACTION the above changes
          sleep(50)                                            // ... repeating until window changes or timeout
        until (oldW<>Form1.Width) or (oldH<>Form1.Height) or (GetTickCount64>I64);

        Image1.Picture.Bitmap.Width:=VTcursor.Width*COLS;      // set width
        Image1.Picture.Bitmap.Height:=VTcursor.Height*ROWS;    // set height
        Image1.Picture.Bitmap.Canvas.Font:=VTcursor.Font;      // copy font details from cursor
        Image1.Picture.Bitmap.Canvas.Font.Style:=[];           // no underline, etc.

        Image2.Picture.Bitmap.Width:=VTcursor.Width*COLS;      // set width
        Image2.Picture.Bitmap.Height:=VTcursor.Height*ROWS;    // set height

        Shape1.Width:=VTcursor.Width*COLS           +4;
        Shape1.Height:=VTcursor.Height*ROWS         +4;

{       for I:=1 to 4 do
        begin
          Application.ProcessMessages;                         // *** ACTION the above changes
          sleep(50)
        end;                                                   // alas, we don't have anything to sync to here   :-(
}
        Form1.AutoSize:=true;
        Form1.WindowState:=wsNormal;
        Form1.Width:=newW;                                     // in theory the form should do this itself
        Form1.Height:=newH;                                    // ... but i'm not entirely trusting of it!
        Form1.Left:=(Screen.Width - newW) div 2;
        Form1.Top:=(Screen.Height - newH) div 2;

{       for I:=1 to 4 do
         begin
           Application.ProcessMessages;                        // *** ACTION the above changes
           sleep(50)
         end;                                                  // alas, we don't have anything to sync to here   :-(
}
        Form1.Constraints.MinWidth:=Form1.Width;
        Form1.Constraints.MaxWidth:=Form1.Width;
        Form1.Constraints.MinHeight:=Form1.Height;
        Form1.Constraints.MaxHeight:=Form1.Height;
//      Form1.BorderIcons:=Form1.BorderIcons-[biMaximize];
        SIZELOCK:=true;                                        //  DISABLE RESIZING

        ResetTerminal;
        OK:=true
      end
    end
  end;

  if not OK then VTcursor.Font:=Memo1.Font;                    // restore saved font details
  Timer1.Enabled:=true;
  Timer2.Enabled:=true;
  Timer3.Enabled:=true;
  Timer4.Enabled:=true
end;                                                                                                                   // ################## down to here #################
*)



// popup menu item - select screen font and size (extremely messy, requires shutting down EVERYTHING while in operation)
procedure TForm1.MenuItem5Click(Sender: TObject);
var newW, newH,                                                        // width and height with new font
    maxW, maxH,                                                        // width and height when maximized
       LBW,TBH:integer;                                                // left border width, top bar height
         point:TPoint;
            OK:boolean;
begin
  FontDiaLog1.Font:=VTcursor.Font;                                     // load current font into font selection dialog
  Memo1.Font:=VTcursor.Font;                                           // save font details in case we need to back out
  OK:=true;

  if FontDialog1.Execute then
  begin
    OK:=false;                                                         // assume font selection is not suitable
    VtCursor.Hide;                                                     // make cursor invisible
    VTcursor.Left:=0;                                                  // move cursor to top left of terminal screen
    VTcursor.Top:=0;
    VTcursor.Font:=FontDialog1.Font;                                   // switch cursor to newly selected font (in particular: name and size)
    VTcursor.Font.Style:=[];                                           // ensure no styles have been selected (bold, italic, etc)

    VTcursor.Width:=VTcursor.Canvas.TextWidth('#');                    // this is to get around Linux Mint 20.x setting the wrong height if AutoSize is on,
    VTcursor.Height:=VTcursor.Canvas.TextHeight('#');                  // on the whole is probably a better solition than using autosize to define size.
    cellW:=VTcursor.Width;
    cellH:=VTcursor.Height;                                            // cellW and cellH make for quicker access for the video.inc routines

    if cellW<8 then ErrorCode:=8 else
    begin
      newW:=Form1.Width -Image1.Picture.Bitmap.Width +(cellW*COLS);    // new form target width, EXCLUDING L+R window borders
      newH:=Form1.Height-Image1.Picture.Bitmap.Height+(cellH*ROWS);    // new form target height, EXCLUDING title bar and bottom window border

      point.X:=Form1.Left;                                             // left edge of Form1's left border, this is OUTSIDE of Form1's working area
      point.Y:=Form1.Top;                                              // top edge of Form1's title bar. again, this is OUTSIDE of Form1's working area

      LBW:=-Form1.ScreenToClient(point).X;                             // ScreenToClient converts to (negative) left border width, sign changed so LBW is positive
      TBH:=-Form1.ScreenToClient(point).Y;                             // ScreenToClient converts to (negative) title bar height, sign changed so TBH is positive

      maxW:=Form1.Monitor.WorkAreaRect.Width-(LBW*2);                  // decrease width. ASSUMES right border is the same width as left border
      maxH:=Form1.Monitor.WorkAreaRect.Height-(TBH+LBW);               // decrease height. ASSUMES bottom border is the same width as left border

//    writeln('cell size : ', cellW, ' x ', cellH);
//    writeln('status bar = ', Shape1.Top, ' pixels high');
//    writeln('vertical padding = ', (Shape1.Height-Panel1.Height), ' pixels');
//    writeln('horizontal padding = ', (Shape1.Width-Panel1.Width), ' pixels');

      if (newW>maxW) or (newH>maxH) then begin
                                           ErrorData[1]:=newW;
                                           ErrorData[2]:=newH;
                                           ErrorData[3]:=maxW;
                                           ErrorData[4]:=maxH;
                                           ErrorCode:=9
                                         end else
      begin
        // *** GOOD TO GO! ***

////////////////////////////////////////////////////////////////////////////////
        Timer1.Enabled:=false;                                                 // pause all timers while changing font.
//      Timer2.Enabled:=false;                                                 // not doing so is just too complicated,
        Timer3.Enabled:=false;                                                 // with risk of something drawing on the
        Timer4.Enabled:=false;                                                 // screen mid-adjustment.
////////////////////////////////////////////////////////////////////////////////

        Form1.Constraints.MinWidth:=0;                                 // ### ENABLE RESIZING
        Form1.Constraints.MaxWidth:=0;
        Form1.Constraints.MinHeight:=0;
        Form1.Constraints.MaxHeight:=0;
//      Application.ProcessMessages;                                   // seems we don't need this anymore

        Shape1.Width:=cellW*COLS         +4;                           // creates a 2-pixel wide border
        Shape1.Height:=cellH*ROWS        +4;                           // around all sides of Panel1

        Image1.Picture.Bitmap.Width:=cellW*COLS;                       // set width
        Image1.Picture.Bitmap.Height:=cellH*ROWS;                      // set height
        Image1.Picture.Bitmap.Canvas.Font:=VTcursor.Font;              // copy font details from cursor
        Image1.Picture.Bitmap.Canvas.Font.Style:=[];                   // no underline, etc.
        Image1.Width:=Image1.Picture.Bitmap.Width;                     // (just in case...)
        Image1.Height:=Image1.Picture.Bitmap.Height;                   // (just in case...)

        Image2.Picture.Bitmap.Width:=cellW*COLS;                       // set width
        Image2.Picture.Bitmap.Height:=cellH*ROWS;                      // set height
        Image2.Width:=Image2.Picture.Bitmap.Width;                     // (just in case...)
        Image2.Height:=Image2.Picture.Bitmap.Height;                   // (just in case...)

        Image3.Left:=(cellW*COLS)-Image3.Width;                        // is always visible when we get here

        Form1.Width:=newW;
        Form1.Height:=newH;
//####  Form1.Left:=(Screen.Width - newW) div 2;
//####  Form1.Top:=(Screen.Height - newH) div 2;

        Form1.Constraints.MinWidth:=newW;
        Form1.Constraints.MaxWidth:=newW;
        Form1.Constraints.MinHeight:=newH;
        Form1.Constraints.MaxHeight:=newH;                             // ### DISABLE RESIZING

////////////////////////////////////////////////////////////////////////////////
        Timer1.Enabled:=true;
//      Timer2.Enabled:=true;
        Timer3.Enabled:=true;
        Timer4.Enabled:=true;
////////////////////////////////////////////////////////////////////////////////

        ResetTerminal(1);
        OK:=true
      end
    end
  end;

  if not OK then begin                                                 // back out, restoring previously saved font details
                   VTcursor.Font:=Memo1.Font;
                   VTcursor.Width:=VTcursor.Canvas.TextWidth('#');
                   VTcursor.Height:=VTcursor.Canvas.TextHeight('#');
                   cellW:=VTcursor.Width;
                   cellH:=VTcursor.Height
                 end;
{
  Timer1.Enabled:=true;
  Timer2.Enabled:=true;
  Timer3.Enabled:=true;
  Timer4.Enabled:=true;
}
end;



// popup menu item - select default text colour
procedure TForm1.MenuItem6MultiClick(Sender: TObject);
var TC:integer;
begin
  if Sender=MenuItem6A then begin TC:=1; MenuItem6A.Checked:=true end else
  if Sender=MenuItem6B then begin TC:=2; MenuItem6B.Checked:=true end else
  if Sender=MenuItem6C then begin TC:=3; MenuItem6C.Checked:=true end else
  if Sender=MenuItem6D then begin TC:=4; MenuItem6D.Checked:=true end else
  if Sender=MenuItem6E then begin TC:=5; MenuItem6E.Checked:=true end else
  if Sender=MenuItem6F then begin TC:=6; MenuItem6F.Checked:=true end else
  if Sender=MenuItem6G then begin TC:=7; MenuItem6G.Checked:=true end else
  if Sender=MenuItem6H then begin TC:=8; MenuItem6H.Checked:=true end
                       else       TC:=-1;
  if TC<>-1 then
  begin
    if InvertBW then begin                                             // undo previous invert
                       PAL[0]:=$00FFFFFF-PAL[0];
                       PAL[15]:=$00FFFFFF-PAL[15];
                       Shape1.Pen.Color:=PAL[0];
                       InvertBW:=false
                     end;

    FGdefault:=min(TC, 7);
    FGcolour:=FGdefault;
    if TC=8 then begin                                                 // invert black and white
                   PAL[0]:=$00FFFFFF-PAL[0];                           // black -> white
                   PAL[15]:=$00FFFFFF-PAL[15];                         // white -> black
                   Shape1.Pen.Color:=PAL[0];
                   InvertBW:=true
                 end
  end
end;



// popup menu item - select how dim attribute is handled (8 vs 16 colour mode)
procedure TForm1.MenuItem7MultiClick(Sender: TObject);
var TD:integer;
begin
  if Sender=MenuItem7A then begin TD:=0; MenuItem7A.Checked:=true end else     // dim attribute enabled
  if Sender=MenuItem7B then begin TD:=1; MenuItem7B.Checked:=true end else     // force bright 1
  if Sender=MenuItem7C then begin TD:=2; MenuItem7C.Checked:=true end          // force bright 2
                       else       TD:=-1;
  if TD<>-1 then Dimopt:=TD
end;



// popup menu item - call up palette editor contained in Unit2
procedure TForm1.MenuItem8Click(Sender: TObject);
var f:TForm2;
    I:integer;
begin
  for I:=0 to 15 do begin
                      PaletteRO[I]:=CVT[I];                            // load 'read only' default palette
                      PaletteRW[I]:=PAL[I]                             // load working palette
                    end;
  if InvertBW then begin                                               // undo inversion of BLACK and WHITE
                     PaletteRW[0]:=$00FFFFFF-PaletteRW[0];
                     PaletteRW[15]:=$00FFFFFF-PaletteRW[15]
                   end;

  f:=TForm2.Create(nil);
  try
    flagPOPUP:=true;

    if f.ShowModal=mrOK then
    begin
      if InvertBW then begin                                           // redo inversion of BLACK and WHITE
                         PaletteRW[0]:=$00FFFFFF-PaletteRW[0];
                         PaletteRW[15]:=$00FFFFFF-PaletteRW[15]
                       end;
      for I:=0 to 15 do PAL[I]:=PaletteRW[I];                          // retrieve working palette
      Shape1.Pen.Color:=PAL[0]
    end
  finally
    flagPOPUP:=false;
    f.Release
  end
end;



// popup menu item - clear graphics layer / text layer / ring buffer
procedure TForm1.MenuItem9MultiClick(Sender: TObject);
begin
  if Sender=MenuItem9A then begin
                          GFXclear(0, 0, Gw, Gh);                      // clear graphics layer
                          Image2.Hide                                  // hide graphics layer
                        end else
  if Sender=MenuItem9B then clear(1, 1, COLS, ROWS) else               // clear text layer
  if Sender=MenuItem9C then RxBuffer.tail:=RxBuffer.head else          // clear ring buffer
  if Sender=MenuItem9D then ResetTerminal(0)
end;



// popup menu item - diagnostics information
procedure TForm1.MenuItem10MultiClick(Sender: TObject);
var DM:integer;
begin
  if Sender=MenuItem10A then begin DM:=0; MenuItem10A.Checked:=true end else
  if Sender=MenuItem10B then begin DM:=1; MenuItem10B.Checked:=true end else
  if Sender=MenuItem10C then begin DM:=2; MenuItem10C.Checked:=true end
                       else DM:=-1;
  if DM<>-1 then DEBUGMODE:=DM
end;



// popup menu item - exit application
procedure TForm1.MenuItem11Click(Sender: TObject);
begin
  Form1.Close
end;






procedure TForm1.FormCreate(Sender: TObject);
var I // ,n1,n2,n3
                :integer;
//            SL:TstringList;
//            RS:TResourceStream;
//            DW:DWORD;
             S:string;
             T:textfile;
begin
  Form1.Caption:='GFXterm64';                                          // updated later on by Timer1
  Application.Title:='GFXterm64';                                      // updated later on by Timer1
  Application.ShowButtonGlyphs:=sbgNever;                              // ensure glyphs not shown on buttons (InputQuery is one offender)

  ConfigName:=GetAppConfigFile(false);                                 // uses Application.Title
//writeln('config file: ', ConfigName);

// attempt to read configuration file. if this fails, set up default palette
  if not ReadConfigurationFile then for I:=0 to 15 do PAL[I]:=CVT[I];
                                                                       //////////////////////////////////////////////////////////////////////////
  cellW:=VTcursor.Canvas.TextWidth('#');                               // this is to get around Linux Mint 20.x conspiring with Lazarus 2.0.12 //
  cellH:=VTcursor.Canvas.TextHeight('#');                              // to set the wrong height if AutoSize is on!                           //
                                                                       //////////////////////////////////////////////////////////////////////////
  VTcursor.Width:=cellW;
  VTcursor.Height:=cellH;

//Application.HintHidePause:=5000;

////////////////////////////////////////////////////////////////////////////////
// the below functionality (loadable .PAL file) is rendered redundant by the
// inclusion of an internal palette editor and the saving and loading of the
// palette to/from the main configuration file at startup and exit.
////////////////////////////////////////////////////////////////////////////////

  S:=ChangeFileExt(ExpandFileName(paramstr(0)),'.pal');
  if FileExists(S) then
  try
    AssignFile(T, S);
    Reset(T);
//  ReWrite(T);                                                        // use to create sample pallette file

    for I:=0 to 15 do
    begin
//    writeln(T,'0x'+Format('%.6x',[PAL[I]]));                         // write to sample file
      ReadLn(T,S);
      if S='' then ReadLn(T,S);
      if pos(' ', S)<>0 then S:=copy(S, 1, pos(' ', S)-1);
      if pos(#08, S)<>0 then S:=copy(S, 1, pos(#08, S)-1);
      PAL[I]:=StrToInt(S)
    end;

    if InvertBW then begin                                             // invert black and white
                       PAL[0]:=$00FFFFFF-PAL[0];                       // black -> white
                       PAL[15]:=$00FFFFFF-PAL[15]                      // white -> black
                     end;

    CloseFile(T)
  except
    for I:=0 to 15 do PAL[I]:=CVT[I];
    try CloseFile(T) except end;
    ShowMessage(#13+pL+'Error reading .PAL file, using default VT palette'+pR+#13)
  end;

////////////////////////////////////////////////////////////////////////////////

  Form1.AutoSize:=true;
  Panel1.AutoSize:=true;

//Form1.AutoScroll:=false;                                             // set in form view
//Form1.KeyPreview:=true;                                              // set in form view
//Form1.DoubleBuffered:=true;                                          // leave unset in form view, below line replaces this
  Panel1.DoubleBuffered:=true;                                         // only double-buffer Panel1 instead of whole form

////////////////////////////////////////////////////////////////////////////////
// start of code to rearrange and resize components for display
////////////////////////////////////////////////////////////////////////////////

  Bevel1.Left:=0;                                                      // used to define top of window and minimum allowed width
  Bevel1.Top:=0;
  Bevel1.Width:=640 + 2 + 2;                                           // (80 characters x 8 pixels) + 2 pixels (left margin) + 2 pixels (right margin)
  Bevel1.Height:=Label1.Canvas.TextHeight('#')+4;

  for I:=0 to ComponentCount-1 do if Components[I] is TLabel then
      if (length(Components[I].Name)=6) and
         (LeftStr(Components[I].Name,5)='Label') and
         (Components[I].Name[6] in ['1'..'8']) then
  begin
{$IFDEF WINDOWS}
    TLabel(Components[I]).Font.Name:='Courier New';                                // ensure is a monospaced font under windows
{$ENDIF}
    TLabel(Components[I]).Left:=TLabel(Components[I]).Left + 2;                    // shuffle the 8 top-bar labels 2 pixels to the right
    TLabel(Components[I]).Top:=TLabel(Components[I]).Top + 2;                      // NEW!!! shuffle the 8 top-bar labels 2 pixels down
    TLabel(Components[I]).Height:=TLabel(Components[I]).Canvas.TextHeight('#')     // this line is to get around Linux Mint 20.x setting the wrong height
  end;                                                                             // (although the problem could be in conjunction with a Lazarus bug)
{$IFDEF WINDOWS}
  Label9.Font.Name:='Courier New';
{$ENDIF}

  Shape1.Left:=0;
//Shape1.Top:=Label1.Height+2;
  Shape1.Top:=Label1.Height+4;                                         // bumped up to match moving the top row down by an extra 2 pixels (see NEW!!! above)
  Shape1.Width:=cellW*COLS     +4;                                     // +4 -> 2 pixel boarder all around
  Shape1.Height:=cellH*ROWS    +4;
  Shape1.Pen.Color:=PAL[0];

  Panel1.Left:=Shape1.Left     +2;                                     // +2 -> centre in boarder (Shape1)
  Panel1.Top:=Shape1.Top       +2;

// create text area
  Image1.Left:=0;                                                      // horizontal position of screen grid
  Image1.Top:=0;                                                       // vertical position of screen grid
(*
  Image1.Picture.Bitmap:=TBitmap.Create;                               // create a bitmap object for text - ****** LAZARUS SEEMS TO DO THIS AUTOMATICALLY ******
*)
  Image1.Picture.Bitmap.Width:=cellW*COLS;                             // set width
  Image1.Picture.Bitmap.Height:=cellH*ROWS;                            // set height
//Image1.Picture.Bitmap.Canvas.TextFlags:=ETO_OPAQUE;                  // opaque writing of text, improves speed       *** NOT SUPPORTED BY LAZARUS ***
  Image1.Picture.Bitmap.Canvas.Font:=VTcursor.Font;                    // copy font details from cursor object
//Image1.Picture.Bitmap.Canvas.Font.Style:=[];                         // no underline, etc.                            \
//Image1.Picture.Bitmap.Canvas.Font.Color:=clWhite;                    // WHITE text by default                          |-- these are all now set in the
//Image1.Picture.Bitmap.Canvas.Brush.Color:=clBlack;                   // default brush: clBlack (for clearing screen)  /             text write routines
  Image1.Width:=Image1.Picture.Bitmap.Width;                           // (just in case...)
  Image1.Height:=Image1.Picture.Bitmap.Height;                         // (just in case...)

// create graphics area
  Image2.Left:=0;                                                      // graphics plane overlays text plane
  Image2.Top:=0;
(*
  Image2.Picture.Bitmap:=TBitmap.Create;                               // create a bitmap object for graphics - ****** LAZARUS SEEMS TO DO THIS AUTOMATICALLY ******
*)
  Image2.Picture.Bitmap.Width:=cellW*COLS;                             // set width
  Image2.Picture.Bitmap.Height:=cellH*ROWS;                            // set height
//Image2.Picture.Bitmap.Canvas.Brush.Color:=clBlack;                   // default brush: clBlack (for clearing screen)  \
//Image2.Picture.Bitmap.Canvas.Pen.Color:=clRed;                       // default pen: clRed (for drawing lines)         |-- these are set in GFXink and
//Image2.Picture.Bitmap.Canvas.Pen.Width:=1;                                                        //                  /         GFXclear, called below
  Image2.Width:=Image2.Picture.Bitmap.Width;                           // (just in case...)
  Image2.Height:=Image2.Picture.Bitmap.Height;                         // (just in case...)

// make graphics area transparent
  Image2.Transparent:=true;                                            // allow transparency (or can be set in form view)
//Image2.Picture.Bitmap.Transparent:=true;                             //         (doesn't seem to be needed with Lazarus/linux)
  Image2.Picture.Bitmap.TransparentColor:=clBlack;                     // transparent colour is black
  Image2.Picture.Bitmap.TransparentMode:=tmFixed;                      // use above setting for TC

// position 'no keyboard input' icon to top left, hidden
  Image3.Left:=0;
  Image3.Top:=0;
  Image3.Width:=Image3.Picture.Bitmap.Width;
  Image3.Height:=Image3.Picture.Bitmap.Height;
//Image3.Autosize:=true;                                               // didn't work reliably, so set size manually with above 2 lines
  Image3.Transparent:=true;
//Image3.Picture.Bitmap.Transparent:=true;                             //         (doesn't seem to be needed with Lazarus/linux)
  Image3.Picture.Bitmap.TransparentColor:=clBlack;                     // transparent colour is black
  Image3.Picture.Bitmap.TransparentMode:=tmFixed;                      // use above setting for TC
  Image3.Hide;                                                         // keep HIDDEN until required (flagFOCUS and not flagPOPUP -> hidden, checked in Timer1 handler)

// position cursor at top left of text area
  VTcursor.Top:=0;                                                     // initial cursor: row 1
  VTcursor.Left:=0;                                                    // initial cursor: column 1
  VTcursor.Font.Color:=clRed;                                          // cursor colour (FG)
  VTcursor.Color:=clRed;                                               // cursor colour (BG)

// configure text copy object
  Memo1.Left:=0;
  Memo1.Top:=0;
(*                                                                     // the following are handled
  Memo1.Width:=cellW*COLS;                                             // within right-click menu's
  Memo1.Height:=cellH*ROWS;                                            // Item3 ("select/copy text")

  Memo1.Font:=VTcursor.Font;
  Memo1.Font.Style:=[];
  Memo1.Font.Color:=clBlack;                                           // black text on
  Memo1.Color:=clSilver;                                               // a silver background

  Memo1.Hint:=' Select the text you want to copy using the mouse, '+#13+       // this text has been moved to form designer
              ' then press control-C to copy it to the clipboard. '+#13+
              ' When finished, press ENTER to exit this view. ';
*)
  Label5.Color:=clLime;                                                // green 'running' annunciator by default
  Label6.Color:=clYellow;                                              // yellow 'logging' annunciator by default
  Label7.Color:=clAqua;                                                // light blue paste annunciator by default

  Label9.Font.Size:=16;
  Panel2.Left:=0;
  Panel2.Top:=0;
//Panel2.Visible:=false;                                               // need to do this in first run of form activate

  OpenDialog1.InitialDir:=ExtractFilePath(ExpandFileName(paramstr(0)));
  SaveDialog1.InitialDir:=ExtractFilePath(ExpandFileName(paramstr(0)));

// align graphics and text layers along the Z-axis
  Memo1.Enabled:=false;                                                // *** probably not needed
  Memo1.Visible:=false;
//Memo1.SendToBack;                                                    // *** probably does nothing, upsets GDK/GTK if placed here

  Image1.Enabled:=false;                                               // ignore mouse and keyboard events
  Image2.Enabled:=false;                                               // ignore mouse and keyboard events
  Image3.Enabled:=false;                                               // ignore mouse and keyboard events

  Image1.BringToFront;                                                 // text layer ends in background
  Image2.BringToFront;                                                 // graphics layer overlays text
  Image3.BringToFront;                                                 // 'NO KEYBOARD' graphic in front, but not visible

  VTcursor.BringToFront;                                               // cursor always on top of text and graphics

// create shortcuts - for EXCLUSIVE use by graphics routines within video.inc
  SCR:=Image1.Picture.Bitmap.Canvas;                                   // shorthand for canvas object (text screen)
  GFX:=Image2.Picture.Bitmap.Canvas;                                   // shorthand for canvas object (graphics screen)

// moved back here as a test to see if locking these down early stops startup flicker when not using AlphaBlend to fade in at startup ################
  Form1.Width:=Shape1.Width;
  Form1.Height:=Shape1.Height+Shape1.Top;
  Form1.Constraints.MinWidth:=Shape1.Width;                            // these next four lines
  Form1.Constraints.MaxWidth:=Shape1.Width;                            // lock the form dimensions
  Form1.Constraints.MinHeight:=Shape1.Height+Shape1.Top;               // so the user can not
  Form1.Constraints.MaxHeight:=Shape1.Height+Shape1.Top;               // change them.

  Form1.Left:=(Form1.Monitor.WorkAreaRect.Width-Form1.Width) div 2;    // approximate centre of screen, ignores title bar height
  Form1.Top:=(Form1.Monitor.WorkAreaRect.Height-Form1.Height) div 2;   // and side border widths, but is the best we can do.

// *****************************************************************************
// in theory form layout is now complete, and form1 is positioned (more-or-less)
// in the middle of the monitor's active area. form still isn't visible, it will
// only be visible when we get to the first call to Form1's activate handler
// *****************************************************************************

  clear(1, 1, COLS, ROWS);                                             // clear text layer
  GFXink(255, 0 ,0 ,1);                                                // default GFX pen: red, 1-pixel wide
  GFXclear(0, 0, Gw, Gh);                                              // clear graphics layer, background set to black
  Image2.Hide;                                                         // graphics layer is turned off initially
  gotoxy(1,1);                                                         // home cursor

  AlphaBlendValue:=0;                                                  // start up invisible, Timer1 handler
  AlphaBlend:=true;                                                    // fades in over approximately 225ms (comment out for testing)

  TCheckThread.Create(false);                                          // enable bell thread
  TSerialThread.Create(false)                                          // enable serial I/O thread
end;



procedure TForm1.FormDestroy(Sender: TObject);
var mark:int64;
begin
  LOGTOFILE:=false;                                            // stop any further logging
  CONNECTED:=0;                                                // stop any further serial I/O
  DEBUGMODE:=0;                                                // stop any further diagnostics output

  WriteConfigurationFile;                                      // #### write configuration file ####
  try Flush(LogFile) except end;
  try CloseFile(LogFile) except end;
  CloseCommPort;

  AlphaBlend:=true;
  repeat                                                       // approx 330ms fadeout
    mark:=GetTickCount64;
    AlphaBlendValue:=max(0, AlphaBlendValue-12);               // (255/12)*15ms = 330ms
    repeat
      Application.ProcessMessages                              // keep GUI ticking over so we can see the fadeout
    until timesince(mark)>15
  until AlphaBlendValue=0;
  sleep(100)
end;



procedure TForm1.ApplicationPropertiesActivate(Sender: TObject);
const startup:boolean=true;
begin
  if startup then                                              // startup things that can/should not be performed until the main form is 'live'
  begin
    startup:=false;

    Panel2.Visible:=false;                                     // can't hide until here otherwise dimensions/location will be wrong when first revealed
    Memo1.SendToBack;                                          // LINUX: generates an error if this is in form1.create, probably does nothing anyway

//  if LastName<>'' then MenuItem1AClick(nil)                  // (experimental - automatic connect)

    TS1:=GetTickCount64;                                       // initialize all timestamps to the startup time
    TS2:=TS1;
    TS3:=TS2;
    TS4:=TS3;
    TS5:=TS4;
    TS6:=TS5;
    TS7:=TS6;
    TS8:=TS7;
    TS9:=TS8;
    Timer1.Enabled:=true;
    Timer3.Enabled:=true;
    Timer4.Enabled:=true
  end;

  flagFOCUS:=true
end;



procedure TForm1.ApplicationPropertiesDeactivate(Sender: TObject);
begin
  flagFOCUS:=false
end;



procedure TForm1.ApplicationPropertiesIdle(Sender: TObject; var Done: Boolean);
begin
  TS9:=GetTickCount64
end;



(*
procedure TForm1.FormResize(Sender: TObject);
begin
  writeln('form resized at: ', GetTickCount64);
end;

procedure TForm1.FormWindowStateChange(Sender: TObject);
begin
  write('form state changed to :');
  if Form1.WindowState=wsFullScreen then writeln('wsFullScreen') else
  if Form1.WindowState=wsMaximized  then writeln('wsMaximized')  else
  if Form1.WindowState=wsMinimized  then writeln('wsMinimized')  else
  if Form1.WindowState=wsNormal     then writeln('wsNormal')
                                    else writeln('- unknown -')
end;

procedure TForm1.ApplicationProperties1Restore(Sender: TObject);
begin
  writeln('application restored')
end;
*)




begin
  {$IFNDEF UseCThreads}
  ShowMessage('To compile and run correctly, the following:'+#09+#13+#13+
              '-dUseCThreads'+#13+#13+
              'needs to be added under:'+#13+#13+
              'Project ->'+#13+
              #09+'Project Options ->'+#13+
              #09+#09+'Compiler Options ->'+#13+
              #09+#09+#09+'Custom Options');
  halt;
  {$ENDIF}
end.

